<?php
	require_once('base.php');
	
	require_once($babAddonPhpPath.'gestutilisateurs_ini.php');
	require_once($babAddonPhpPath.'import_inc.php');
	require_once($babAddonPhpPath.'functions.php');
	
	if (!bab_isUserAdministrator())
	{
		$babBody->addError(undecode_html(bab_translate("Access denied", $GLOBALS['babAddonFolder'])));
		exit;
	}
	
	function mail_domain_setting_form()
	{
		global $babBody;
		class mail_domain_setting_form_class
		{
			function mail_domain_setting_form_class()
			{
				global $babBody;
				global $babDB;
				
				$submit_flag =  bab_pp('submit_flag', '');
			
				$this->validate = bab_translate("Validate", $GLOBALS['babAddonFolder']);
				$this->mail_domain_message = undecode_html(bab_translate("Give the default name of the mail domain.", $GLOBALS['babAddonFolder']));
				$this->information_tooltip = undecode_html(bab_translate("The default mail domain will be used to build the default mail adresses for all imported users.", $GLOBALS['babAddonFolder']));
				
				if (empty($submit_flag))
				{
					$babBody->addError(undecode_html(bab_translate("Setting of the default mail domain", $GLOBALS['babAddonFolder'])));
					$this->default_mail_domain_value = DEFAULT_MAIL_DOMAIN_VALUE;
				}
				else
				{
					$mail_domain = bab_pp('mail_domain', '');
					
					if (!empty($mail_domain))
					{
						if (!is_regular_mail('toto@'.$mail_domain))
						{
							$babBody->addError(sprintf(undecode_html(bab_translate("Error in the mail domain: the mail domain %s is not regular.", $GLOBALS['babAddonFolder'])), $mail_domain));
							$error_flag = true;
						}
						else
						{
							$res = $babDB->db_query("
							SELECT
							`gestuser_parameters`.`id`
							FROM
							`gestuser_parameters`,
							`bab_sites`
							WHERE
							`id_site` = `bab_sites`.`id`
							AND
							`name` = '".$babDB->db_escape_string($GLOBALS['babSiteName'])."'
							");
							if ($babDB->db_num_rows($res) > 0)
							{
								$var = $babDB->db_fetch_array($res);
								$id = $var['id'];
								$res = $babDB->db_query("
								UPDATE
								`gestuser_parameters`
								SET
								`default_site_mail_domain` = '".$babDB->db_escape_string($mail_domain)."'
								WHERE
								`id` = '".$babDB->db_escape_string($id)."'
								");
							}
							else
							{
								$res = $babDB->db_query("
								SELECT
								`id`
								FROM
								`bab_sites`
								WHERE
								`name` = '".$babDB->db_escape_string($GLOBALS['babSiteName'])."'
								");
								$var = $babDB->db_fetch_array($res);
								$id_site = $var['id'];
								$res = $babDB->db_query("
								INSERT
								INTO
								`gestuser_parameters`
								(
									`id_site`, 
									`default_site_mail_domain`
								)
								VALUES(
									'".$babDB->db_escape_string($id_site)."',
									'".$babDB->db_escape_string($mail_domain)."'
									)
								");
							}
							$babBody->addError(sprintf(undecode_html(bab_translate("The new default mail domain %s is registered.", $GLOBALS['babAddonFolder'])), $mail_domain));
						}
					}
					else
					{
						$res = $babDB->db_query("
						SELECT
						`gestuser_parameters`.`id`
						FROM
						`gestuser_parameters`,
						`bab_sites`
						WHERE
						`id_site` = `bab_sites`.`id`
						AND
						`name` = '".$babDB->db_escape_string($GLOBALS['babSiteName'])."'
						");
						if ($babDB->db_num_rows($res) > 0)
						{
							$var = $babDB->db_fetch_array($res);
							$id = $var['id'];
							$res = $babDB->db_query("
							UPDATE
							`gestuser_parameters`
							SET
							`default_site_mail_domain` = '".$babDB->db_escape_string($mail_domain)."'
							WHERE
							`id` = '".$babDB->db_escape_string($id)."'
							");
						}
						else
						{
							$res = $babDB->db_query("
							SELECT
							`id`
							FROM
							`bab_sites`
							WHERE
							`name` = '".$babDB->db_escape_string($GLOBALS['babSiteName'])."'
							");
							$var = $babDB->db_fetch_array($res);
							$id_site = $var['id'];
							$res = $babDB->db_query("
							INSERT
							INTO
							`gestuser_parameters`
							(
								`id_site`, 
								`default_site_mail_domain`
							)
							VALUES(
								'".$babDB->db_escape_string($id_site)."',
								'".$babDB->db_escape_string($mail_domain)."'
								)
							");
						}
						$babBody->addError(undecode_html(bab_translate("The default mail domain is now blank.", $GLOBALS['babAddonFolder'])));
					}
					$this->default_mail_domain_value = $mail_domain;
				}
			}
		}
		$obj= new mail_domain_setting_form_class();
		$babBody->babecho(bab_printTemplate($obj, $GLOBALS['babAddonHtmlPath']."admin.html", "set_mail_domain")); 
	}
	
	$babBody->title = undecode_html(bab_translate("Parameters for the addon", $GLOBALS['babAddonFolder']));
	mail_domain_setting_form()
?>