<?php

// Dfinition de l'encodage utilis
if (!defined("CHARSET"))
{
	switch (mb_strtolower(mysql_client_encoding()))
	{
		case "utf8":
			define("CHARSET", "UTF-8");
			break;
		case 'latin1':
		default:
			define ("CHARSET", "ISO-8859-15");
			break;
	}
}

// Dcodage HTML
if (!function_exists('undecode_html'))
{
	function undecode_html($string)
	{
		return html_entity_decode($string, ENT_QUOTES, CHARSET);
	}
}

if (!function_exists('replaceInvalidCharactersInName'))
{
	function replaceInvalidCharactersInName($str)
	{
		$str = htmlentities($str, ENT_NOQUOTES, "ISO-8859-15");
	 
		// Remplacer les entits HTML pour avoir juste le premier caractres non accentus
		// Exemple : "&eacute;" => "e", "&Eacute;" => "E", " " => "a" ...
		$str = preg_replace('#&([A-Za-z])(?:acute|grave|cedil|circ|orn|ring|slash|th|tilde|uml);#', '\1', $str);
		 
		// Remplacer les ligatures tel que : ,  ...
		// Exemple "" => "oe"
		$str = preg_replace('#&([A-Za-z]{2})(?:lig);#', '\1', $str);
		// Supprimer tout le reste
		$str = preg_replace('#&[^;]+;#', '', $str);
		
		return $str;
	} 
}

// Suppression de la dlgation d'identifiant id (construite  partir de la fonction native d'Ovidentia incluse dans admin.delegat.php du noyau)
if (!function_exists('delete_delegation'))
{
	function delete_delegation($id)
	{
		global $babDB;

		$idsafe = $babDB->db_escape_string($id);

		include_once $GLOBALS['babInstallPath']."utilit/delincl.php";
		include_once $GLOBALS['babInstallPath']."utilit/calincl.php";
		$res = $babDB->db_query("select id from ".BAB_SECTIONS_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteSection($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_TOPICS_CATEGORIES_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteTopicCategory($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_FLOW_APPROVERS_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteApprobationSchema($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_FORUMS_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteForum($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_FAQCAT_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteFaq($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_FM_FOLDERS_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteFolder($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_LDAP_DIRECTORIES_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteLdapDirectory($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_DB_DIRECTORIES_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteDbDirectory($arr['id']);
		}

		$res = $babDB->db_query("select id from ".BAB_ORG_CHARTS_TBL." where id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteOrgChart($arr['id']);
		}

		$res = $babDB->db_query("select crt.id, ct.id as idcal from ".BAB_CAL_PUBLIC_TBL." crt left join ".BAB_CALENDAR_TBL." ct on ct.owner=crt.id and ct.type='".BAB_CAL_PUB_TYPE."' where crt.id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteCalendar($arr['idcal']);
			$babDB->db_query("delete from ".BAB_CAL_PUBLIC_TBL." where id='".$arr['id']."'");
		}

		$res = $babDB->db_query("select crt.id, ct.id as idcal from ".BAB_CAL_RESOURCES_TBL." crt left join ".BAB_CALENDAR_TBL." ct on ct.owner=crt.id and ct.type='".BAB_CAL_RES_TYPE."' where crt.id_dgowner='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteCalendar($arr['idcal']);
			$babDB->db_query("delete from ".BAB_CAL_RESOURCES_TBL." where id='".$arr['id']."'");
		}

		// Suppression complmentaire des entres des fichiers dans les tables bab_files et bab_files_tags
		$res = $babDB->db_query("SELECT `id` FROM ".BAB_FILES_TBL." WHERE `iIdDgOwner` = '".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			$babDB->db_query("DELETE FROM ".BAB_FILES_TAGS_TBL." WHERE `id_file` = '".$babDB->db_escape_string($arr['id'])."'");
			$babDB->db_query("DELETE FROM ".BAB_FILES_TBL." WHERE `id` = '".$babDB->db_escape_string($arr['id'])."'");
		}

		// Suppression complmentaire de l'espace projet
		include_once $GLOBALS['babInstallPath']."utilit/tmIncl.php";
		$res = $babDB->db_query("SELECT id FROM ".BAB_TSKMGR_PROJECTS_SPACES_TBL." WHERE `idDelegation` ='".$idsafe."'");
		while($arr = $babDB->db_fetch_array($res))
		{
			bab_deleteProjectSpace($arr['id']);
		}

		$babDB->db_query("delete from ".BAB_DG_ADMIN_TBL." where id_dg='".$idsafe."'");
		$babDB->db_query("delete from ".BAB_DG_GROUPS_TBL." where id='".$idsafe."'");
		$babDB->db_query("delete from ".BAB_DG_ACL_GROUPS_TBL." where id_object='".$idsafe."'");
	}
}

// Suppression d'un groupe et de ses enfants
if (!function_exists('remove_group_and_all_children'))
{
	function remove_group_and_all_children($id_group)
	{
		global $babDB;
		$sub_groups = bab_getGroups($id_group, true);
		if (count($sub_groups) > 0)
		{
			foreach ($sub_groups["id"] as $id_sub_group)
			{
				if ($id_sub_group > 0) bab_removeGroup($id_sub_group);
			}
		}
		bab_removeGroup($id_group);
	}
}

// Cration d'une dlgation
if (!function_exists('create_delegation'))
{
	function create_delegation($delegation_name, $type, $years_number, $password)
	{
		global $babDB;

		require_once $GLOBALS['babInstallPath'].'utilit/artapi.php';
		require_once $GLOBALS['babInstallPath'].'admin/acl.php';

		$admin_status = false;
		$gest_status = false;
		$existing_delegation = false;

		$id_type_group = FindGroupIdFromName($type, BAB_REGISTERED_GROUP);
		if ($id_type_group == false)
		{
			exit();
		}

		// Cration du groupe dlgu
		$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name)));
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM `bab_groups`
		WHERE
		(`name` = '".$babDB->db_escape_string($name)."')
		AND
		(`id_parent` = '".$babDB->db_escape_string($id_type_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$description = "";
			switch($type)
			{
				case 'LGT':
					$description = undecode_html(bab_translate("Group for the level", $GLOBALS['babAddonFolder'])." ".$delegation_name);
					break;
				case 'LP':
				case 'STS':
					$description = undecode_html(bab_translate("Group for the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
					break;
			}
			$managerid = $GLOBALS['BAB_SESS_USERID'];
			$parent = $id_type_group;
			$id_delegated_group = bab_createGroup($name, $description, $managerid, $parent);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_delegated_group = $temp["id"];
		}

		// Cration de l'annuaire sur le groupe dlgu
		$id_group = $id_delegated_group;
		$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name)));
		$description = undecode_html(bab_translate("Directory for the delegated group", $GLOBALS['babAddonFolder'])." ".$group_name);
		$id_dgowner = 0;
		$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
		// Mise en place des droits sur l'annuaire cr
		// Droits pour le groupe des administrateurs du site : Voir, Modifier, Ajouter, Supprimer, Importer, Exporter, Effacer
		set_right_on_directory($id_directory,"view", BAB_ADMINISTRATOR_GROUP);
		set_right_on_directory($id_directory,"update", BAB_ADMINISTRATOR_GROUP);
		set_right_on_directory($id_directory,"add", BAB_ADMINISTRATOR_GROUP);
		set_right_on_directory($id_directory,"del", BAB_ADMINISTRATOR_GROUP);
		set_right_on_directory($id_directory,"import", BAB_ADMINISTRATOR_GROUP);
		set_right_on_directory($id_directory,"export", BAB_ADMINISTRATOR_GROUP);
		set_right_on_directory($id_directory,"empty", BAB_ADMINISTRATOR_GROUP);

		// Cration de la dlgation
		switch($type)
		{
			case "LGT":
				$description = undecode_html(bab_translate("Delegation for the level", $GLOBALS['babAddonFolder'])." ".$delegation_name);
				break;
			case "LP":
			case "STS":
				$description = undecode_html(bab_translate("Delegation for the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
				break;
		}
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_dg_groups`
		WHERE
		(`id_group` = '".$id_delegated_group."')
		AND
		(`name` = '".$babDB->db_escape_string(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))))."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_dg_groups`
			(
			`name`,
			`description`,
			`groups`,
			`sections`,
			`articles`,
			`faqs`,
			`forums`,
			`calendars`,
			`mails`,
			`directories`,
			`approbations`,
			`filemanager`,
			`orgchart`,
			`taskmanager`,
			`id_group`
			) VALUES
			(
			'".$babDB->db_escape_string(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))))."',
			'".$babDB->db_escape_string($description)."',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'Y',
			'".$babDB->db_escape_string($id_delegated_group)."'
			)");
			$id_delegation = $babDB->db_insert_id();
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_delegation = $temp['id'];
			$res = $babDB->db_query("
			UPDATE
			`bab_dg_groups`
			SET
			`description` = '".$babDB->db_escape_string($description)."',
			`groups` = 'Y',
			`sections` = 'Y',
			`articles` = 'Y',
			`faqs` = 'Y',
			`forums` = 'Y',
			`calendars` = 'Y',
			`mails` = 'Y',
			`directories` = 'Y',
			`approbations` = 'Y',
			`filemanager` = 'Y',
			`orgchart` ='Y',
			`taskmanager` = 'Y'
			WHERE
			(
			`id` = '".$babDB->db_escape_string($id_delegation)."'
			)"
			);
		}

		// Mise en place des ACL sur la dlgation cre sur tous les utilisateurs
		$res= $babDB->db_query("
		DELETE FROM
		`bab_dg_acl_groups`
		WHERE
		`id_object` = '".$babDB->db_escape_string($id_delegation)."'
		");
		$res= $babDB->db_query("
		INSERT INTO
		`bab_dg_acl_groups`
		(`id_object`, `id_group`)
		VALUES
		(
		'".$id_delegation."',
		'".BAB_ALLUSERS_GROUP."'
		)"
		);

		// Cration ventuelle du compte de l'administrateur dlgu
		$firstname = ADMIN_FIRSTNAME ;
		$lastname = str_replace(" ", "", ucwords(mb_strtolower($delegation_name)));
		$middlename = "";
		$email = DEFAULT_MAIL;
		$nickname = $lastname.$firstname;
		$password1 = $password;
		$password2 = $password;
		$confirmed = true;
		$error = "";
		$bgroup = true;
		$id_user = bab_getUserIdByNickname($nickname);
		if ($id_user == 0)
		{
			$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup);
			$admin_status = true;
		}
		$info = bab_getUserInfos($id_user);
		$info['cn'] = $nickname;
		$info['disabled '] = false;
		$error = '';
		bab_updateUserById($id_user, $info, $error);
		
		// Inscription de l'administrateur dlgu dans le groupe des administrateurs dlgus
		$id_group = FindGroupIdFromName(ADMINS_GROUP_NAME, BAB_REGISTERED_GROUP);
		if ($id_group != false)
		{
			bab_attachUserToGroup($id_user, $id_group);
		}
		// Nomination de l'administrateur dlgu comme administrateur dlgu
		$res = $babDB->db_query("
		SELECT
		`id_user`
		FROM `bab_dg_admin`
		WHERE
		(`id_user` = '".$babDB->db_escape_string($id_user)."')
		AND
		(`id_dg` = '".$babDB->db_escape_string($id_delegation)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_dg_admin`
			(
			`id_user`,
			`id_dg`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_user)."',
			'".$babDB->db_escape_string($id_delegation)."'
			)"
			);
		}
		// Inscription de l'administrateur dlgu dans le groupe dlgu
		bab_attachUserToGroup($id_user, $id_delegated_group);
		// Inscription de l'administrateur dlgu dans le groupe parent du groupe dlgu
		bab_attachUserToGroup($id_user, $id_type_group);

		// Cration ventuelle du compte du gestionnaire dlgu
		$firstname = GEST_FIRSTNAME ;
		$lastname = str_replace(" ", "", ucwords(mb_strtolower($delegation_name)));
		$middlename = "";
		$email = DEFAULT_MAIL;
		$nickname = $lastname.$firstname;
		$password1 = $password;
		$password2 = $password;
		$confirmed = true;
		$error = "";
		$bgroup = true;
		$id_user = bab_getUserIdByNickname($nickname);
		if ($id_user == 0)
		{
			$id_user = bab_registerUser($firstname, $lastname, $middlename, $email, $nickname, $password1, $password2, $confirmed, $error, $bgroup);
			$gest_status = true;
		}
		$info = bab_getUserInfos($id_user);
		$info['cn'] = $nickname;
		$info['disabled '] = false;
		$error = '';
		bab_updateUserById($id_user, $info, $error);
		
		// Inscription de l'administrateur dlgu dans le groupe des administrateurs dlgus
		$id_group = FindGroupIdFromName(GESTS_GROUP_NAME, BAB_REGISTERED_GROUP);
		if ($id_group != false)
		{
			bab_attachUserToGroup($id_user, $id_group);
		}
		// Inscription du gestionnaire dlgu dans le groupe dlgu
		bab_attachUserToGroup($id_user, $id_delegated_group);
		// Inscription du gestionnaire dlgu dans le groupe parent du groupe dlgu
		bab_attachUserToGroup($id_user, $id_type_group);

		// laboration de l'arborescence des sous-groupes

		// Cration du groupe des gestionnaires de la dlgation
		$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).MANAGERS_GROUP_SUFFIX;
		switch($type)
		{
			case 'LGT':
				$description = undecode_html(bab_translate("Group of managers for the level", $GLOBALS['babAddonFolder'])." ".$delegation_name);

				break;
			case 'LP':
			case 'STS':
				$description = undecode_html(bab_translate("Group of managers for the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
				break;
		}
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = $id_delegated_group;
		$res = $babDB->db_query("
		SELECT `id` FROM `bab_groups`
		WHERE
		(`name` = '".$babDB->db_escape_string($name)."')
		AND
		(`id_parent` = ".$parent.")
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$id_gest_group = bab_createGroup( $name, $description, $managerid, $parent);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_gest_group = $temp["id"];
		}
		// Inscription du gestionnaire dlgu dans le groupe des gestionnaires de la dlgation
		bab_attachUserToGroup($id_user, $id_gest_group);
		// Cration de l'annuaire du groupe des gestionnaires dlgus
		$id_group = $id_gest_group;
		$group_name = $name;
		switch($type)
		{
			case 'LGT':
				$description = undecode_html(bab_translate("Directory for the group of managers for the level", $GLOBALS['babAddonFolder'])." ".$delegation_name);

				break;
			case 'LP':
			case 'STS':
				$description = undecode_html(bab_translate("Directory for the group of managers for the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
				break;
		}
		$id_dgowner = $id_delegation;
		// Cration de l'annuaire du groupe des gestionnaires de la dlgation
		$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
		// Mise en place des droits sur l'annuaire cr
		// Droits Voir pour le groupe dlgu
		// Droits pour le groupe des gestionnaires dlgus : Voir, Modifier, Ajouter, Supprimer, Importer, Exporter, Effacer
		set_right_on_directory($id_directory,"view", $id_delegated_group);
		set_right_on_directory($id_directory,"update", $id_gest_group);
		set_right_on_directory($id_directory,"add", $id_gest_group);
		set_right_on_directory($id_directory,"del", $id_gest_group);
		set_right_on_directory($id_directory,"import", $id_gest_group);
		set_right_on_directory($id_directory,"export", $id_gest_group);
		set_right_on_directory($id_directory,"empty", $id_gest_group);

		// Cration du groupe des partenaires de la dlgation (LP et STS uniquement)
		switch ($type)
		{
			case 'LP':
			case 'STS':
				$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).PARTNERS_GROUP_SUFFIX;
				$description = undecode_html(bab_translate("Group of partners for the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
				$managerid = $GLOBALS['BAB_SESS_USERID'];
				$parent = $id_delegated_group;
				$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE (`name` = '".$babDB->db_escape_string($name)."') AND (`id_parent` = ".$parent.")");
				if ($babDB->db_num_rows($res) == 0)
				{
					$id_part_group = bab_createGroup( $name, $description, $managerid, $parent);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_part_group = $temp["id"];
				}
				// Mise en place des options sur le groupe des partenaires
				$res = $babDB->db_query("
				UPDATE `bab_groups`
				SET
				`mail` = 'N',
				`ustorage` = 'Y',
				`notes` = 'Y',
				`contacts` = 'Y',
				`directory` = 'Y',
				`pcalendar` = 'Y',
				`id_ocentity` = '0'
				WHERE
				`id` = '".$id_part_group."'"
				);
				$id_group = $id_part_group;
				$group_name = $name;
				$description = undecode_html(bab_translate("Directory for the group of partners for the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
				$id_dgowner = $id_delegation;
				$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
				// Mise en place des droits sur l'annuaire des partenaires
				// Droit pour le groupe delegu : Voir
				// Droit pour le groupe des gestionnaires : Modifier, Ajouter, Supprimer, Importer, Exporter, Effacer
				set_right_on_directory($id_directory,"view", $id_delegated_group);
				set_right_on_directory($id_directory,"update", $id_gest_group);
				set_right_on_directory($id_directory,"add", $id_gest_group);
				set_right_on_directory($id_directory,"del", $id_gest_group);
				set_right_on_directory($id_directory,"import", $id_gest_group);
				set_right_on_directory($id_directory,"export", $id_gest_group);
				set_right_on_directory($id_directory,"empty", $id_gest_group);
				break;
		}

		// Cration des sous-groupes correspondant aux diffrentes annes de formation de la dlgation
		switch ($type)
		{
			case 'LGT':
				$learners_group = undecode_html(bab_translate("Group of pupils for the level", $GLOBALS['babAddonFolder']));
				$directory_learners_group = undecode_html(bab_translate("Directory of pupils for the level", $GLOBALS['babAddonFolder']));
				$teachers_group = undecode_html(bab_translate("Group of teachers for the level", $GLOBALS['babAddonFolder']));
				$directory_teachers_group = undecode_html(bab_translate("Directory of teachers for the level ", $GLOBALS['babAddonFolder']));
				break;
			case 'LP':
				$learners_group = undecode_html(bab_translate("Group of pupils for the course", $GLOBALS['babAddonFolder']));
				$directory_learners_group = undecode_html(bab_translate("Directory of pupils for the course", $GLOBALS['babAddonFolder']));
				$teachers_group = undecode_html(bab_translate("Group of teachers for the course", $GLOBALS['babAddonFolder']));
				$directory_teachers_group = undecode_html(bab_translate("Directory of teachers for the course", $GLOBALS['babAddonFolder']));
				break;
			case 'STS':
				$learners_group = undecode_html(bab_translate("Group of students for the course", $GLOBALS['babAddonFolder']));
				$directory_learners_group = undecode_html(bab_translate("Directory of students for the course", $GLOBALS['babAddonFolder']));
				$teachers_group = undecode_html(bab_translate("Group of teachers for the course", $GLOBALS['babAddonFolder']));
				$directory_teachers_group = undecode_html(bab_translate("Directory of teachers for the course ", $GLOBALS['babAddonFolder']));
				break;
		}
		for ($i = 1; $i <= $years_number; $i++)
		{
			// Cration du groupe des apprenants de la ime anne de la dlgation
			if ($years_number == 1)
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX;
				$description = undecode_html(bab_translate($learners_group, $GLOBALS['babAddonFolder'])." ".$delegation_name);
			}
			else
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
				$description = undecode_html(bab_translate($learners_group, $GLOBALS['babAddonFolder'])." ".$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']));
			}
			$managerid = $GLOBALS['BAB_SESS_USERID'];
			$parent = $id_delegated_group;
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			(`name` = '".$babDB->db_escape_string($group_name)."')
			AND
			(`id_parent` = ".$babDB->db_escape_string($parent).")
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$id_elv_group = bab_createGroup( $group_name, $description, $managerid, $parent);
			}
			else
			{
				$temp = $babDB->db_fetch_array($res);
				$id_elv_group = $temp["id"];
			}
			$id_group = $id_elv_group;
			if ($years_number == 1)
			{
				$description = undecode_html(bab_translate($directory_learners_group, $GLOBALS['babAddonFolder'])." ".$delegation_name);
			}
			else
			{
				$description = undecode_html(bab_translate($directory_learners_group, $GLOBALS['babAddonFolder'])." ".$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']));
			}
			$id_dgowner = $id_delegation;
			// Cration de l'annuaire des apprenants de la ime anne de formation
			$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
			// Mise en place des droits sur l'annuaire des apprenants de la ime anne de formation
			// Droit pour le groupe dlgu : Voir
			// Droit pour le groupe des gestionnaires : Modifier, Ajouter, Supprimer, Importer, Exporter, Effacer
			set_right_on_directory($id_directory,"view", $id_delegated_group);
			set_right_on_directory($id_directory,"update", $id_gest_group);
			set_right_on_directory($id_directory,"add", $id_gest_group);
			set_right_on_directory($id_directory,"del", $id_gest_group);
			set_right_on_directory($id_directory,"import", $id_gest_group);
			set_right_on_directory($id_directory,"export", $id_gest_group);
			set_right_on_directory($id_directory,"empty", $id_gest_group);

			// Cration du groupe des enseignants de la ime anne de la dlgation
			if ($years_number == 1)
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX;
				$description = undecode_html(bab_translate($teachers_group, $GLOBALS['babAddonFolder'])." ".$delegation_name);
			}
			else
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
				$description = undecode_html(bab_translate($teachers_group, $GLOBALS['babAddonFolder'])." ".$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']));
			}
			$managerid = $GLOBALS['BAB_SESS_USERID'];
			$parent = $id_delegated_group;
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			(`name` = '".$babDB->db_escape_string($group_name)."')
			AND
			(`id_parent` = ".$parent.")
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$id_prof_group = bab_createGroup( $group_name, $description, $managerid, $parent);
			}
			else
			{
				$temp = $babDB->db_fetch_array($res);
				$id_prof_group = $temp["id"];
			}
			$id_group = $id_prof_group;
			if ($years_number == 1)
			{
				$description = undecode_html(bab_translate($directory_teachers_group, $GLOBALS['babAddonFolder'])." ".$delegation_name);
			}
			else
			{
				$description = undecode_html(bab_translate($directory_teachers_group, $GLOBALS['babAddonFolder'])." ".$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']));
			}
			$id_dgowner = $id_delegation;
			// Cration du groupe des enseignants de la ime anne de formation
			$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
			// Mise en place des droits sur l'annuaire des enseignants de la ime anne de formation
			// Droit pour le groupe dlgu : Voir
			// Droit pour le groupe des gestionnaires : Modifier, Ajouter, Supprimer, Importer, Exporter, Effacer
			set_right_on_directory($id_directory,"view", $id_delegated_group);
			set_right_on_directory($id_directory,"update", $id_gest_group);
			set_right_on_directory($id_directory,"add", $id_gest_group);
			set_right_on_directory($id_directory,"del", $id_gest_group);
			set_right_on_directory($id_directory,"import", $id_gest_group);
			set_right_on_directory($id_directory,"export", $id_gest_group);
			set_right_on_directory($id_directory,"empty", $id_gest_group);

			// Cration du groupe des enseignants responsable de projets de la ime anne de la dlgation (LP et STS)
			switch ($type)
			{
				case 'LP':
				case 'STS':
					if ($years_number == 1)
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).PROJECT_RESPONSIBLE_GROUP_SUFFIX;
						$description = undecode_html(bab_translate("Group of responsible teachers for projects in the course", $GLOBALS['babAddonFolder'])." ".$delegation_name);
					}
					else
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.PROJECT_RESPONSIBLE_GROUP_SUFFIX;
						$description = undecode_html(bab_translate("Group of responsible teachers for projects in the course", $GLOBALS['babAddonFolder'])." ".$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']));
					}
					$managerid = $GLOBALS['BAB_SESS_USERID'];
					$parent = $id_delegated_group;
					$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE (`name` = '".$babDB->db_escape_string($name)."') AND (`id_parent` = ".$parent.")");
					if ($babDB->db_num_rows($res) == 0)
					{
						$id_prof_projet_group = bab_createGroup( $name, $description, $managerid, $parent);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_prof_projet_group = $temp["id"];
					}
					// Mise en place des options sur le groupe groupe des enseignants responsables de projets
					$res = $babDB->db_query("
					UPDATE
					`bab_groups`
					SET
					`mail` = 'N',
					`ustorage` = 'N',
					`notes` = 'N',
					`contacts` = 'N',
					`directory` = 'N',
					`pcalendar` = 'N',
					`id_ocentity` = '0'
					WHERE
					`id` = '".$babDB->db_escape_string($id_prof_projet_group)."'
					");
					// Mise en place du schma de modration propre au groupe des enseignants responsables de projets
					if ($years_number == 1)
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).PROJECT_FLOW_APPROVERS_SUFFIX;
					}
					else
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.PROJECT_FLOW_APPROVERS_SUFFIX;
					}
					$formula = $id_gest_group."|".$id_prof_projet_group;
					$res = $babDB->db_query("
					SELECT
					`id`
					FROM
					`bab_flow_approvers`
					WHERE
					(`name` = '".$babDB->db_escape_string($name)."')
					AND
					(`id_dgowner` = '".$id_delegation."')
					");
					if ($babDB->db_num_rows($res) == 0)
					{
						$res= $babDB->db_query("
						INSERT INTO
						bab_flow_approvers
						(
						name,
						formula,
						forder,
						refcount,
						id_dgowner,
						satype
						)
						VALUES
						(
						'".$babDB->db_escape_string($name)."',
						'".$formula."',
						'N',
						'0',
						'".$babDB->db_escape_string($id_delegation)."',
						'2'
						)
						");
					}
					break;
				case "LGT":
				default:
					break;
			}
			// Cration de l'annuaire DlgationProjet (LP et STS) de type base de donnes
			switch ($type)
			{
				case "LP":
				case "STS":
					$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).PROJECT_SUFFIX;
					$res = $babDB->db_query("SELECT `id` FROM `bab_db_directories` WHERE (`name` = '".$babDB->db_escape_string($name)."') AND (`id_dgowner` = '".$id_delegation."')");
					if ($babDB->db_num_rows($res) == 0)
					{
						$res = $babDB->db_query("INSERT INTO `bab_db_directories` (`name`, `description`, `id_group`, `id_dgowner`, `user_update`, `ovml_list`, `ovml_detail`, `show_update_info`) VALUES ('".$babDB->db_escape_string($name)."', '', '0', '".$id_delegation."', 'Y', '',  '', 'N')");
						$id_directory = $babDB->db_insert_id($res);
					}
					else
					{
						$temp = $babDB->db_fetch_array($res);
						$id_directory = $temp["id"];
					}
					// Slection et ordre des champs  visualiser dans l'annuaire
					$res = $babDB->db_query("
					SELECT
					`id`
					FROM
					`bab_dbdir_fieldsextra`
					WHERE
					`id_directory` = '".$babDB->db_escape_string($id_directory)."'");
					if ($babDB->db_num_rows($res) == 0)
					{
						$res = $babDB->db_query("
						INSERT
						INTO
						`bab_dbdir_fieldsextra`
						(
						`id_directory`,
						`id_field`,
						`default_value`,
						`modifiable`,
						`required`,
						`multilignes`,
						`ordering`
						)
						VALUES
						(
						'".$babDB->db_escape_string($id_directory)."',
						'1',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'2',
						'0',
						'Y',
						'Y',
						'N',
						'1'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'3',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'4',
						'0',
						'Y',
						'Y',
						'N',
						'2'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'5',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'6',
						'0',
						'Y',
						'N',
						'N',
						'11'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'7',
						'0',
						'Y',
						'N',
						'N',
						'8'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'8',
						'0',
						'Y',
						'N',
						'N',
						'10'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'9',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'10',
						'0',
						'Y',
						'N',
						'N',
						'9'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'11',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'12',
						'0',
						'Y',
						'N',
						'N',
						'4'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'13',
						'0',
						'Y',
						'Y',
						'N',
						'3'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'14',
						'0',
						'Y',
						'N',
						'N',
						'5'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'15',
						'0',
						'Y',
						'N',
						'N',
						'7'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'16',
						'0',
						'Y',
						'N',
						'N',
						'6'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'17',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						('".$babDB->db_escape_string($id_directory)."',
						'18',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'19',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'20',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'21',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'22',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'23',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'24',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						('".$babDB->db_escape_string($id_directory)."',
						'25',
						'0',
						'Y',
						'N',
						'N',
						'0'
						),
						(
						'".$babDB->db_escape_string($id_directory)."',
						'26',
						'0',
						'Y',
						'N',
						'N',
						'0'
						)");

					}
					// Droit Voir sur l'annuaire pour le groupe dlgu
					set_right_on_directory($id_directory, "view", $id_delegated_group);
					// Droits Modifier, Ajouter, Importer, Exporter, Effacer pour les groupes des apprenants de la delegation
					if ($years_number == 1)
					{
						$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX;
					}
					else
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
					}
					$id_parent = $id_delegated_group;
					$id_group =  FindGroupIdFromName($group_name, $id_parent);
					set_right_on_directory($id_directory, "modify", $id_group);
					set_right_on_directory($id_directory, "add", $id_group);
					set_right_on_directory($id_directory, "import", $id_group);
					set_right_on_directory($id_directory, "export", $id_group);
					set_right_on_directory($id_directory, "del", $id_group);
					// Droits Modifier, Ajouter, Importer, Exporter, Effacer pour les groupes des enseignants
					if ($years_number == 1)
					{
						$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX;
					}
					else
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
					}
					$id_parent = $id_delegated_group;
					$id_group =  FindGroupIdFromName($group_name, $id_parent);
					set_right_on_directory($id_directory, "modify", $id_group);
					set_right_on_directory($id_directory, "add", $id_group);
					set_right_on_directory($id_directory, "import", $id_group);
					set_right_on_directory($id_directory, "export", $id_group);
					set_right_on_directory($id_directory, "del", $id_group);
					// Droits Modifier, Ajouter, Importer, Exporter, Effacer pour le groupe des partenaires de la dlgation
					if (isset($id_part_group))
					{
						set_right_on_directory($id_directory, "modify", $id_part_group);
						set_right_on_directory($id_directory, "add", $id_part_group);
						set_right_on_directory($id_directory, "import", $id_part_group);
						set_right_on_directory($id_directory, "export", $id_part_group);
						set_right_on_directory($id_directory, "del", $id_part_group);
					}
					// Droits Modifier, Ajouter, Importer, Exporter, Effacer, Vider pour le groupe des gestionnaires de la dlgation
					set_right_on_directory($id_directory, "modify", $id_gest_group);
					set_right_on_directory($id_directory, "add", $id_gest_group);
					set_right_on_directory($id_directory, "import", $id_gest_group);
					set_right_on_directory($id_directory, "export", $id_gest_group);
					set_right_on_directory($id_directory, "del", $id_gest_group);
					set_right_on_directory($id_directory, "empty", $id_gest_group);
					break;
				
				case "LGT":
				default:
					break;
			}
		}

		// Schma d'approbation de la dlgation
		$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).FLOW_APPROVERS_SUFFIX;
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_flow_approvers`
		WHERE
		(`name` = '".$babDB->db_escape_string($name)."')
		AND
		(`id_dgowner` = '".$babDB->db_escape_string($id_delegation)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$formula = $id_gest_group;
			for ($i = 1; $i <= $years_number; $i++)
			{
				if ($years_number == 1)
				{
					$formula = $formula."|".$id_prof_group;
				}
				else
				{
					$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
					$id_parent = $id_delegated_group;
					$id_group =  FindGroupIdFromName($group_name, $id_parent);
					$formula = $formula."|".$id_group;
				}
			}
			$res = $babDB->db_query("
			INSERT INTO bab_flow_approvers
			(
			name,
			formula,
			forder,
			refcount,
			id_dgowner,
			satype
			)
			VALUES
			(
			'".$babDB->db_escape_string($name)."',
			'".$babDB->db_escape_string($formula)."',
			'N',
			'0',
			'".$babDB->db_escape_string($id_delegation)."',
			'2'
			)"
			);
			$id_delegation_flow_approvers = $babDB->db_insert_id($res);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_delegation_flow_approvers = $temp["id"];
		}
		// Schma d'approbation des diffrentes annes de formation de la dlgation
		if ($years_number > 1)
		{
			for ($i = 1; $i <= $years_number; $i++)
			{
				$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.FLOW_APPROVERS_SUFFIX ;
				$res = $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_flow_approvers`
				WHERE
				(`name` = '".$babDB->db_escape_string($name)."')
				AND
				(`id_dgowner` = '".$babDB->db_escape_string($id_delegation)."')
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$formula = $id_gest_group;
					$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
					$id_parent = $id_delegated_group;
					$id_group =  FindGroupIdFromName($group_name, $id_parent);
					$formula = $formula."|".$id_group;

					$res = $babDB->db_query("
					INSERT INTO bab_flow_approvers
					(
					name,
					formula,
					forder,
					refcount,
					id_dgowner,
					satype
					)
					VALUES
					(
					'".$babDB->db_escape_string($name)."',
					'".$babDB->db_escape_string($formula)."',
					'N',
					'0',
					'".$babDB->db_escape_string($id_delegation)."',
					'2'
					)
					");
				}
			}
		}

		// Gestionnaire de fichiers

		// Dossier Espace <dlgation>
		$folder = "Espace ".$delegation_name;
		$id_dgowner = $id_delegation;
		$relative_path = "";
		$bhide = "N";
		$idsa = 0;
		$auto_approbation = "Y";
		$filenotify = "N";
		$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $auto_approbation, $filenotify);
		// Mise en place des droits
		// Droit pour les utilisateurs enregistrs : Tlcharger
		// Droits pour les apprenants : Dposer
		// Droits pour les enseignants : Dposer, Mettre  jour
		// Droits pour les gestionnaires de la filire :  Dposer, Mettre  jour, Grer
		// Droits dcompresser pour personne
		set_right_on_folder($id_folder, "download", BAB_REGISTERED_GROUP);
		for ($i = 1; $i < $years_number + 1; $i++)
		{
			if ($years_number == 1) $group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX; else $group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
			$id_parent = $id_delegated_group;
			$id_group = FindGroupIdFromName($group_name, $id_parent);
			if ($id_group != false)
			{
				set_right_on_folder($id_folder, "upload", $id_group);
			}
			if ($years_number == 1) $group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX; else $group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
			$id_parent = $id_delegated_group;
			$id_group = FindGroupIdFromName($group_name, $id_parent);
			if ($id_group != false)
			{
				set_right_on_folder($id_folder, "upload", $id_group);
				set_right_on_folder($id_folder, "update", $id_group);
			}
		}
		set_right_on_folder($id_folder, "upload", $id_gest_group);
		set_right_on_folder($id_folder, "update", $id_gest_group);
		set_right_on_folder($id_folder, "manage", $id_gest_group);

		// Dossier Stages (LP et STS)
		switch ($type)
		{
			case "LP":
			case "STS":
				$folder = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STAGES_SUFFIX;
				$id_dgowner = $id_delegation;
				$relative_path = "";
				$bhide = "N";
				$idsa = 0;
				$auto_approbation = "Y";
				$filenotify = "N";
				$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $auto_approbation, $filenotify);
				// Mise en place des droits sur le dossier
				for ($i = 1; $i <= $years_number; $i++)
				{
					// Droits pour les apprenants : Dposer, Tlcharger
					if ($years_number == 1)
					{
						$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX;
					}
					else
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
					}
					$id_parent = $id_delegated_group;
					$id_group =  FindGroupIdFromName($group_name, $id_parent);
					set_right_on_folder($id_folder, "upload", $id_group);
					set_right_on_folder($id_folder, "download", $id_group);
					// Droits pour les enseignants : Dposer, Tlcharger, Mettre  jour
					if ($years_number == 1)
					{
						$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX;
					}
					else
					{
						$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
					}
					$id_parent = $id_delegated_group;
					$id_group =  FindGroupIdFromName($group_name, $id_parent);
					set_right_on_folder($id_folder, "upload", $id_group);
					set_right_on_folder($id_folder, "download", $id_group);
					set_right_on_folder($id_folder, "update", $id_group);
				}
				// Droits pour les partenaires : Dposer , Tlcharger
				if (isset($id_part_group))
				{
					set_right_on_folder($id_folder, "upload", $id_part_group);
					set_right_on_folder($id_folder, "download", $id_part_group);
				}
				// Droits pour les gestionnaires : Dposer , Tlcharger, Mettre  jour, Grer
				set_right_on_folder($id_folder, "upload", $id_gest_group);
				set_right_on_folder($id_folder, "download", $id_gest_group);
				set_right_on_folder($id_folder, "update", $id_gest_group);
				set_right_on_folder($id_folder, "manage", $id_gest_group);
				break;
				
			case "LGT":
			default:
				break;
		}

		// Dossier Enseignements
		$folder = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).ENSEIGNEMENT_SUFFIX;
		$id_dgowner = $id_delegation;
		$relative_path = "";
		$bhide = "N";
		$idsa = 0;
		$auto_approbation = "Y";
		$filenotify = "N";
		$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $auto_approbation, $filenotify);
		// Mise en place des droits sur le dossier
		for ($i = 1; $i <= $years_number; $i++)
		{
			// Droits pour les apprenants : Dposer, Tlcharger
			if ($years_number == 1)
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX;
			}
			else
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
			}
			$id_parent = $id_delegated_group;
			$id_group =  FindGroupIdFromName($group_name, $id_parent);
			if ($id_group != false)
			{
				set_right_on_folder($id_folder, "upload", $id_group);
				set_right_on_folder($id_folder, "download", $id_group);
			}
			// Droits pour les enseignants : Dposer, Mettre  jour
			if ($years_number == 1)
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX;
			}
			else
			{
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
			}
			$id_parent = $id_delegated_group;
			$id_group =  FindGroupIdFromName($group_name, $id_parent);
			if ($id_group != false)
			{
				set_right_on_folder($id_folder, "upload", $id_group);
				set_right_on_folder($id_folder, "update", $id_group);
			}
		}
		// Droits pour tous les enseignants de l'tablissement : Tlcharger
		$group_name = TEACHERS_GROUP_NAME;
		$id_parent = BAB_REGISTERED_GROUP;
		$id_group =  FindGroupIdFromName($group_name, $id_parent);
		if ($id_group != false)
		{
			set_right_on_folder($id_folder, "download", $id_group);
		}
		// Droits pour les partenaires : Dposer , Tlcharger
		if (isset($id_part_group))
		{
			set_right_on_folder($id_folder, "upload", $id_part_group);
			set_right_on_folder($id_folder, "download", $id_part_group);
		}
		// Droits pour les gestionnaires : Dposer , Tlcharger, Mettre  jour, Grer
		set_right_on_folder($id_folder, "upload", $id_gest_group);
		set_right_on_folder($id_folder, "download", $id_gest_group);
		set_right_on_folder($id_folder, "update", $id_gest_group);
		set_right_on_folder($id_folder, "manage", $id_gest_group);
		
		// Dossier pour chacune des annes de formation (STS et LP si le nombre d'anne de formation est suprieur  1)
		if (($type != "LGT") && ($years_number > 1))
		{
			for ($i = 1; $i < $years_number + 1; $i++)
			{
				$folder = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i;
				$id_dgowner = $id_delegation;
				$relative_path = "";
				$bhide = "N";
				$idsa = 0;
				$auto_approbation = "Y";
				$filenotify = "N";
				$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $auto_approbation, $filenotify);
				// Mise en place des droits sur le dossier
				// Droits pour les apprenants de l'anne de formation : Dposer, Tlcharger
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
				$id_parent = $id_delegated_group;
				$id_group =  FindGroupIdFromName($group_name, $id_parent);
				if ($id_group != false)
				{
					set_right_on_folder($id_folder, "upload", $id_group);
					set_right_on_folder($id_folder, "download", $id_group);
				}
				// Droits pour les enseignants de l'anne de formation : Tlcharger, Dposer, Mettre  jour
				$group_name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
				$id_parent = $id_delegated_group;
				$id_group =  FindGroupIdFromName($group_name, $id_parent);
				if ($id_group != false)
				{
					set_right_on_folder($id_folder, "download", $id_group);
					set_right_on_folder($id_folder, "upload", $id_group);
					set_right_on_folder($id_folder, "update", $id_group);
				}
				// Droits pour les partenaires : Dposer, Tlcharger
				if (isset($id_part_group))
				{
					set_right_on_folder($id_folder, "upload", $id_part_group);
					set_right_on_folder($id_folder, "download", $id_part_group);
				}
				// Droits pour les gestionnaires : Dposer , Tlcharger, Mettre  jour, Grer
				set_right_on_folder($id_folder, "upload", $id_gest_group);
				set_right_on_folder($id_folder, "download", $id_gest_group);
				set_right_on_folder($id_folder, "update", $id_gest_group);
				set_right_on_folder($id_folder, "manage", $id_gest_group);
			}
		}
		
		// Agendas collectifs
		if ($type != "LGT")
		{
			for ($i = 1; $i <= $years_number; $i++)
			{
				// Agenda collectif des enseignants de l'anne de formation
				if ($years_number == 1)
				{
					$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX;
					$description = undecode_html(bab_translate("Public calendar for the teachers of ", $GLOBALS['babAddonFolder']).$delegation_name);
				}
				else
				{
					$name = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX;
					$description = undecode_html(bab_translate("Public calendar for the teachers of ", $GLOBALS['babAddonFolder']).$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']));
				}
				$idsa = 0;
				$id_dgowner = $id_delegation;
				$id_calendar = create_public_calendar($name, $description, $idsa, $id_dgowner);
				// Droits pour les enseignants : Consulter, Groupe d'utilisateurs
				$group_name = $name;
				$id_parent = $id_delegated_group;
				$id_group = FindGroupIdFromName($group_name, $id_parent);
				set_right_on_public_calendar($id_calendar, "view", $id_group);
				set_right_on_public_calendar($id_calendar, "manage", $id_group);
				set_right_on_public_calendar($id_calendar, "groups", $id_group);
				// Droits pour les gestionnaires : Consulter, Grer pour les gestionnaires
				set_right_on_public_calendar($id_calendar, "view", $id_gest_group);
				set_right_on_public_calendar($id_calendar, "manage", $id_gest_group);

				// Agenda collectif des apprenants (lves/tudiants) seulement
				if ($years_number == 1)
				{
					$name_calendar = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX;
					switch($type)
					{
						case "LP":
							$description = undecode_html(bab_translate("Public calendar for the pupils of ", $GLOBALS['babAddonFolder']).$delegation_name);
							break;
						case "STS":
							$description = undecode_html(bab_translate("Public calendar for the students of ", $GLOBALS['babAddonFolder']).$delegation_name);
							break;
						default:
							break;
					}
					$name_flow_approval = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).FLOW_APPROVERS_SUFFIX;
				}
				else
				{
					$name_calendar = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX;
					switch($type)
					{
						case "LP":
							$description = undecode_html(bab_translate("Public calendar for the pupils of ", $GLOBALS['babAddonFolder'])).$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']);
							break;
						case "STS":
							$description = undecode_html(bab_translate("Public calendar for the students of ", $GLOBALS['babAddonFolder'])).$delegation_name." ".ordinal($i)." ".bab_translate("year", $GLOBALS['babAddonFolder']);
							break;
					}
					$name_flow_approval = str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.FLOW_APPROVERS_SUFFIX;
				}
				$id_dgowner = $id_delegation;
				$idsa = FindFlowApproverIdFromName($name_flow_approval, $id_dgowner);
				$id_calendar = create_public_calendar($name_calendar, $description, $idsa, $id_dgowner);
				// Droit pour les apprenants : Consulter, Groupe
				if ($years_number == 1)
				{
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX, $id_delegated_group);
				}
				else
				{
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX, $id_delegated_group);
				}
				set_right_on_public_calendar($id_calendar, "view", $id_group);
				set_right_on_public_calendar($id_calendar, "groups", $id_group);
				// Droit pour les enseignants : Consulter, Grer
				if ($years_number == 1)
				{
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX, $id_delegated_group);
				}
				else
				{
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX, $id_delegated_group);
				}
				if ($id_group != false)
				{
					set_right_on_public_calendar($id_calendar, "view", $id_group);
					set_right_on_public_calendar($id_calendar, "manage", $id_group);
				}
				// Droit pour les gestionnaires : Consulter, Grer
				set_right_on_public_calendar($id_calendar, "view", $id_gest_group);
				set_right_on_public_calendar($id_calendar, "manage", $id_gest_group);
			}
		}
		// Gestionnaires du thsaurus : non implment

		// Articles

		require_once($GLOBALS['babAddonPhpPath'].'default_topics_categories.php');

		$categories_and_topics_array = categories_and_topics($type, $delegation_name);

		$category = $categories_and_topics_array['category'];
		$space = $categories_and_topics_array['space'];
		$stages = $categories_and_topics_array['stages'];
		$topics_array = $categories_and_topics_array['topics_array'];

		// Catgorie de thmes parente propre  la dlgation
		$res = $babDB->db_query("
		SELECT `id`
		FROM
		`bab_topics_categories`
		WHERE
		(`id_parent` = '0')
		AND
		(`id_dgowner` = '".$babDB->db_escape_string($id_delegation)."')
		");

		if ($babDB->db_num_rows($res) == 0)
		{
			$name = $category;
			$description = "";
			$benabled = "Y";
			$template = "template";
			$disptmpl = "default";
			$topcatid = 0;
			$dgowner = $id_delegation;
			$id_topics_category = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_topics_category = $temp["id"];
		}

		// Mise en place des droits par dfaut sur les thmes de la catgorie
		// Droits pour les apprenants : Lire, Soumettre des articles, Soumettre des commentaires
		// Droits pour les enseignants : Modifier les articles
		// Droits pour les enseignants de l'tablissement : Lire, Soumettre des articles, Soumettre des commentaires
		// Droit pour les gestionnaires : Lire, Grer
		if ($years_number > 1)
		{
			for ($i = 1; $i <= $years_number; $i++)
			{
				$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX, $id_delegated_group);
				set_def_right_on_topics_category($id_topics_category, "view", $id_group);
				set_def_right_on_topics_category($id_topics_category, "submit", $id_group);
				set_def_right_on_topics_category($id_topics_category, "comment", $id_group);
				$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX, $id_delegated_group);
				set_def_right_on_topics_category($id_topics_category, "modify", $id_group);
			}
		}
		else
		{
			$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX, $id_delegated_group);
			set_def_right_on_topics_category($id_topics_category, "view", $id_group);
			set_def_right_on_topics_category($id_topics_category, "submit", $id_group);
			set_def_right_on_topics_category($id_topics_category, "comment", $id_group);
			$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX, $id_delegated_group);
			set_def_right_on_topics_category($id_topics_category, "modify", $id_group);
		}
		set_def_right_on_topics_category($id_topics_category, "view", TEACHERS_GROUP_ID);
		set_def_right_on_topics_category($id_topics_category, "submit", TEACHERS_GROUP_ID);
		set_def_right_on_topics_category($id_topics_category, "comment", TEACHERS_GROUP_ID);

		set_def_right_on_topics_category($id_topics_category, "view", $id_gest_group);
		set_def_right_on_topics_category($id_topics_category, "manage", $id_gest_group);

		// Cration du thme Espace <dlgation>
		$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE (`category` = '".$babDB->db_escape_string(undecode_html($space))."') AND (`id_cat` = '".$babDB->db_escape_string($id_topics_category)."')");
		if ($babDB->db_num_rows($res) == 0)
		{
			$name = undecode_html($space);
			$description = "";
			$idCategory = $id_topics_category;
			$topicArr = array();
			$topicArr["idsaart"] = $id_delegation_flow_approvers;
			$topicArr["idsacom"] = $id_delegation_flow_approvers;
			$topicArr["idsa_update"] = $id_delegation_flow_approvers;
			$topicArr["notify"] = "Y";
			$topicArr["lang"] = "fr";
			$topicArr["article_tmpl"] = "";
			$topicArr["display_tmpl"] = "";
			$topicArr["restrict_access"] = "Y";
			$topicArr["allow_hpages"] = "N";
			$topicArr["allow_pubdates"] = "N";
			$topicArr["allow_attachments"] = "N";
			$topicArr["allow_update"] = "1";
			$topicArr["allow_manupdate"] = "1";
			$topicArr["max_articles"] = 10;
			$topicArr["auto_approbation"] = "Y";
			$topicArr["busetags"] = "N";
			$topicArr["allow_unsubscribe"] = "1";
			$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
			// Suppression des droits hrits lors de la cration du thme
			unset_def_right_on_topics_category($id_topic, "view");
			unset_def_right_on_topics_category($id_topic, "submit");
			unset_def_right_on_topics_category($id_topic, "comment");
			unset_def_right_on_topics_category($id_topic, "modify");
			unset_def_right_on_topics_category($id_topic, "manage");

			// Dfinition des droits propres au thme Espace <dlgation>
			// Droit pour les utilisateurs enregistrs : Lire
			// Droits pour les apprenants : Soumettre des articles,
			// Droits pour  les enseignants : Soumettre des articles, Modifier les articles
			// Droit pour tous les enseignants de l'tablissement : Soumettre des commentaires

			set_right_on_topic($id_topic, "view", BAB_REGISTERED_GROUP);

			if($years_number == 1)
			{
				$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX, $id_delegated_group);
				set_right_on_topic($id_topic, "submit", $id_group);
				$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX, $id_delegated_group);
				set_right_on_topic($id_topic, "submit", $id_group);
				set_right_on_topic($id_topic, "modify", $id_group);
			}
			else
			{
				for ($i = 1; $i <= $years_number; $i++)
				{
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX, $id_delegated_group);
					set_right_on_topic($id_topic, "submit", $id_group);
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX, $id_delegated_group);
					set_right_on_topic($id_topic, "submit", $id_group);
					set_right_on_topic($id_topic, "modify", $id_group);
				}
			}
			set_right_on_topic($id_topic, "comment", TEACHERS_GROUP_ID);
			// Droit pour les gestionnaires : Grer le thme
			set_right_on_topic($id_topic, "manage", $id_gest_group);
		}

		if (isset($stages))
		{
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_topics`
			WHERE
			`category` = '".$babDB->db_escape_string(undecode_html($stages))."'
			AND
			`id_cat` = '".$babDB->db_escape_string($id_topics_category)."'
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$name = undecode_html($stages);
				$description = "";
				$idCategory = $id_topics_category;
				$topicArr = array();
				$topicArr["idsaart"] = $id_delegation_flow_approvers;
				$topicArr["idsacom"] = $id_delegation_flow_approvers;
				$topicArr["idsa_update"] = $id_delegation_flow_approvers;
				$topicArr["notify"] = "Y";
				$topicArr["lang"] = "fr";
				$topicArr["article_tmpl"] = "";
				$topicArr["display_tmpl"] = "";
				$topicArr["restrict_access"] = "Y";
				$topicArr["allow_hpages"] = "N";
				$topicArr["allow_pubdates"] = "N";
				$topicArr["allow_attachments"] = "N";
				$topicArr["allow_update"] = "1";
				$topicArr["allow_manupdate"] = "1";
				$topicArr["max_articles"] = 10;
				$topicArr["auto_approbation"] = "Y";
				$topicArr["busetags"] = "N";
				$topicArr["allow_unsubscribe"] = "1";
				$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);

				// Suppression des droits hrits lors de la cration du thme

				unset_def_right_on_topics_category($id_topic, "view");
				unset_def_right_on_topics_category($id_topic, "submit");
				unset_def_right_on_topics_category($id_topic, "comment");
				unset_def_right_on_topics_category($id_topic, "modify");
				unset_def_right_on_topics_category($id_topic, "manage");

				// Mise en place des droits propres au thme Stages et Projets
				// Droit pour les apprenants : Lire, Soumettre des articles, Soumettre des commentaires
				// Droit pour les enseignants : Lire, Soumettre des articles, Soumettre des commentaires, Modifier les articles
				// Droit pour les partenaires : Lire, Soumettre des articles, Soumettre des commentaires
				// Droit pour les gestionnaires : Lire, Modifier les articles, Grer
				if ($years_number == 1)
				{
					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX, $id_delegated_group);
					set_right_on_topic($id_topic, "view", $id_group);
					set_right_on_topic($id_topic, "submit", $id_group);
					set_right_on_topic($id_topic, "comment", $id_group);

					$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX, $id_delegated_group);
					set_right_on_topic($id_topic, "view", $id_group);
					set_right_on_topic($id_topic, "submit", $id_group);
					set_right_on_topic($id_topic, "comment", $id_group);
					set_right_on_topic($id_topic, "modify", $id_group);
				}
				else
				{
					for ($i = 1; $i <= $years_number; $i++)
					{
						$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX, $id_delegated_group);
						set_right_on_topic($id_topic, "view", $id_group);
						set_right_on_topic($id_topic, "submit", $id_group);
						set_right_on_topic($id_topic, "comment", $id_group);

						$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX, $id_delegated_group);
						set_right_on_topic($id_topic, "view", $id_group);
						set_right_on_topic($id_topic, "submit", $id_group);
						set_right_on_topic($id_topic, "comment", $id_group);
						set_right_on_topic($id_topic, "modify", $id_group);
					}
				}
				if (isset($id_part_group))
				{
					set_right_on_topic($id_topic, "view", $id_part_group);
					set_right_on_topic($id_topic, "submit", $id_part_group);
					set_right_on_topic($id_topic, "comment", $id_part_group);
				}
				set_right_on_topic($id_topic, "view", $id_gest_group);
				set_right_on_topic($id_topic, "modify", $id_gest_group);
				set_right_on_topic($id_topic, "manage", $id_gest_group);
			}
		}

		// Dfinition des thmes gnraux de la dlgation
		$topics_number = count($topics_array);

		if ($topics_number > 0)
		{
			for ($i = 0; $i < $topics_number; $i++)
			{
				// Cration du thme d'ordre i de la dlgation
				$topic = $topics_array[$i];
				$res= $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_topics`
				WHERE
				(`category` = '".$babDB->db_escape_string(undecode_html($topic))."')
				AND
				(`id_cat` = '".$babDB->db_escape_string($id_topics_category)."')
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$name = undecode_html($topic);
					$description = "";
					$idCategory = $id_topics_category;
					$topicArr = array();
					$topicArr["idsaart"] = $id_delegation_flow_approvers;
					$topicArr["idsacom"] = $id_delegation_flow_approvers;
					$topicArr["idsa_update"] = $id_delegation_flow_approvers;
					$topicArr["notify"] = "Y";
					$topicArr["lang"] = "fr";
					$topicArr["article_tmpl"] = "";
					$topicArr["display_tmpl"] = "";
					$topicArr["restrict_access"] = "Y";
					$topicArr["allow_hpages"] = "N";
					$topicArr["allow_pubdates"] = "N";
					$topicArr["allow_attachments"] = "N";
					$topicArr["allow_update"] = "1";
					$topicArr["allow_manupdate"] = "1";
					$topicArr["max_articles"] = 10;
					$topicArr["auto_approbation"] = "Y";
					$topicArr["busetags"] = "N";
					$topicArr["allow_unsubscribe"] = "1";
					$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
				}
			}
		}

		// Cration des thmes correspondant aux diffrentes annes de formation de la dlgation
		if ($years_number > 1)
		{
			for ($i = 1; $i <= $years_number; $i++)
			{
				// Dfinition du schma de modration de l'anne de formation
				$name = str_replace(" ", "", undecode_html(ucwords(mb_strtolower($delegation_name)))).$i.FLOW_APPROVERS_SUFFIX;
				$res= $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_flow_approvers`
				WHERE
				(`name` = '".$babDB->db_escape_string(undecode_html($name))."')
				AND
				(`id_dgowner` = '".$babDB->db_escape_string($id_delegation)."')
				AND
				(`satype` = '2')
				");
				$temp = $babDB->db_fetch_array($res);
				$id_flow_approvers = $temp["id"];

				// Cration de la catgorie de thmes pour chaque anne de la dlgation
				$category = undecode_html(mb_strtoupper($delegation_name)." ".ordinal($i)." ".bab_translate('year', $GLOBALS['babAddonFolder']));
				$res = $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_topics_categories`
				WHERE
				(`title` = '".$babDB->db_escape_string($category)."')
				AND
				(`id_parent` = '".$babDB->db_escape_string($id_topics_category)."')
				");
				if ($babDB->db_num_rows($res) == 0)
				{
					$name = $category;
					$description = "";
					$benabled = "N";
					$template = "template";
					$disptmpl = "default";
					$topcatid = $id_topics_category;
					$dgowner = $id_delegation;
					$id_top_cat = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_top_cat = $temp["id"];
				}

				// Supppression des droits hrits lors de la cration de la sous-catgorie
				unset_def_right_on_topics_category($id_top_cat, "view");
				unset_def_right_on_topics_category($id_top_cat, "submit");
				unset_def_right_on_topics_category($id_top_cat, "comment");
				unset_def_right_on_topics_category($id_top_cat, "modify");
				unset_def_right_on_topics_category($id_top_cat, "manage");

				// Mise en place des droits par dfaut sur la catgorie de thmes
				// Droit pour les apprenants de l'anne de formation : Lire, Soumettre des articles, Soumettre des commentaires
				// Droit pour les enseignants de l'anne de formation : Lire, Soumettre des articles, Soumettre des commentaires, Modifier
				// Droits pour les gestionnaires : Lire, Modifier les aricles, Grer
				$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX, $id_delegated_group);
				set_def_right_on_topics_category($id_top_cat, "view", $id_group);
				set_def_right_on_topics_category($id_top_cat, "submit", $id_group);
				set_def_right_on_topics_category($id_top_cat, "comment", $id_group);
				$id_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX, $id_delegated_group);
				set_def_right_on_topics_category($id_top_cat, "view", $id_group);
				set_def_right_on_topics_category($id_top_cat, "submit", $id_group);
				set_def_right_on_topics_category($id_top_cat, "comment", $id_group);
				set_def_right_on_topics_category($id_top_cat, "modify", $id_group);
				set_def_right_on_topics_category($id_top_cat, "modify", $id_gest_group);
				set_def_right_on_topics_category($id_top_cat, "view", $id_gest_group);
				set_def_right_on_topics_category($id_top_cat, "manage", $id_gest_group);

				// Cration des thmes de l'anne de formation de la dlgation
				for ($j = 1; $j <= TOPICS_DEFAULT_NUMBER; $j++)
				{
					$theme = $delegation_name.$i." - Thme N ".$j;
					$res = $babDB->db_query("SELECT `id` FROM `bab_topics` WHERE (`category` = '".$theme."') AND (id_cat = '".$id_top_cat."')");
					if ($babDB->db_num_rows($res) == 0)
					{
						$name = $theme;
						$description = "";
						$idCategory = $id_top_cat;
						$topicArr = array();
						$topicArr["idsaart"] = $id_flow_approvers;
						$topicArr["idsacom"] = $id_flow_approvers;
						$topicArr["idsa_update"] = $id_flow_approvers;
						$topicArr["notify"] = "Y";
						$topicArr["lang"] = "fr";
						$topicArr["article_tmpl"] = "";
						$topicArr["display_tmpl"] = "";
						$topicArr["restrict_access"] = "Y";
						$topicArr["allow_hpages"] = "N";
						$topicArr["allow_pubdates"] = "N";
						$topicArr["allow_attachments"] = "N";
						$topicArr["allow_update"] = "1";
						$topicArr["allow_manupdate"] = "1";
						$topicArr["max_articles"] = 10;
						$topicArr["auto_approbation"] = "Y";
						$topicArr["busetags"] = "N";
						$topicArr["allow_unsubscribe"] = "1";
						$id_topic = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
					}
				}
			}
		}

		// Espace projets du gestionnaire de projets (LP et STS)
		switch ($type)
		{
			case "LP":
			case "STS":
				for ($i = 1; $i <= $years_number; $i++)
				{
					// Cration de l'espace de projets correspondant  chaque anne de formation de la dlgation considre
					if ($years_number == 1) $name = $delegation_name; else $name = $delegation_name." ".ordinal($i)." anne";
					$id_dgowner = $id_delegation;
					$id_projects_space = create_projects_space($name, $id_dgowner);
					// Mise en place des droits par dfaut sur l'espace projet
					if ($years_number == 1) 
					{
						$id_elv_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).STUDENTS_GROUP_SUFFIX, $id_delegated_group) ;
						$id_prof_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).TEACHERS_GROUP_SUFFIX, $id_delegated_group) ;
					}
					else 
					{
						$id_elv_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.STUDENTS_GROUP_SUFFIX, $id_delegated_group ) ;
						$id_prof_group = FindGroupIdFromName(str_replace(" ", "", ucwords(mb_strtolower($delegation_name))).$i.TEACHERS_GROUP_SUFFIX, $id_delegated_group) ;
					}	
					if (($id_elv_group != false) || ($id_prof_group != false)) set_default_rights_on_projects_space($id_projects_space, $id_elv_group, $id_prof_group);
				}
				break;
			case "LGT":
				break;
		}
		return(array($admin_status, $gest_status));
	}
}

// Cration d'une classe 
if (!function_exists('create_class'))
{
	function create_class($class_name, $level, $type)
	{
		global $babDB;

		// Recherche du groupe dlgu
		$res = $babDB->db_query("
		SELECT
		`child`.`id` AS `id_delegated_group`,
		`parent`.`id` AS `id_parent_group`
		FROM
		`bab_groups` AS `child`,
		`bab_groups` AS `parent`
		WHERE
		(UPPER(`child`.`name`) = UPPER('".$babDB->db_escape_string($level)."'))
		AND
		(`child`.`id_parent` = `parent`.`id`)
		AND
		(UPPER(`parent`.`name`) = UPPER('".$babDB->db_escape_string($type)."'))
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$temp = $babDB->db_fetch_array($res);
			$id_delegated_group = $temp["id_delegated_group"];
			$id_parent_group = $temp["id_parent_group"];

			// Id de la dlgation
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_dg_groups`
			WHERE
			`id_group` = '".$babDB->db_escape_string($id_delegated_group)."'
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$temp = $babDB->db_fetch_array($res);
				$id_delegation = $temp["id"];
			}
			else
			{
				$id_delegation = 0;
			}

			// Id du groupe des gestionnaires de la dlgation
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			(UPPER(`name`) = UPPER('".$babDB->db_escape_string($level.MANAGERS_GROUP_SUFFIX)."'))
			AND
			(`id_parent` = '".$babDB->db_escape_string($id_delegated_group)."')
			");

			if ($babDB->db_num_rows($res) > 0)
			{
				$temp = $babDB->db_fetch_array($res);
				$id_gest_group = $temp["id"];
			}
			else
			{
				$id_gest_group = 0;
			}

			// Id du groupe des lves au sein de la dlgation
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			(UPPER(`name`) = UPPER('".$babDB->db_escape_string($level.STUDENTS_GROUP_SUFFIX)."'))
			AND
			(`id_parent` = '".$babDB->db_escape_string($id_delegated_group)."')
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$temp = $babDB->db_fetch_array($res);
				$id_elv_delegated_group = $temp["id"];
			}
			// Id du groupe des enseignants au sein de la dlgation
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			(UPPER(`name`) = UPPER('".$babDB->db_escape_string($level.TEACHERS_GROUP_SUFFIX)."'))
			AND
			(`id_parent` = '".$babDB->db_escape_string($id_delegated_group)."')
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$temp = $babDB->db_fetch_array($res);
				$id_prof_delegated_group = $temp["id"];
			}
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			(UPPER(`name`) = UPPER('".$babDB->db_escape_string($level.TEACHERS_GROUP_SUFFIX)."'))
			AND
			(`id_parent` = '".$babDB->db_escape_string($id_delegated_group)."')
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$temp = $babDB->db_fetch_array($res);
				$id_prof_delegated_group = $temp["id"];
			}

			$is_existing_class = false;

			// Cration du groupe des lves de la classe
			$name = $class_name.STUDENTS_GROUP_SUFFIX;
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			UPPER(`name`) = UPPER('".$babDB->db_escape_string($name)."')
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$description = undecode_html(bab_translate("Group for the pupils of the class", $GLOBALS['babAddonFolder']))." ".mb_strtoupper($class_name, CHARSET);
				$managerid = $GLOBALS["BAB_SESS_USERID"];
				$parent = $id_delegated_group;
				$id_elv_group = bab_createGroup( $name, $description, $managerid, $parent);
			}
			else
			{
				$temp= $babDB->db_fetch_array($res);
				$id_elv_group = $temp["id"];;
				$is_existing_class = true;
			}
			// Cration de l'annuaire sur le groupe des lves de la classe
			$res = $babDB->db_query("
			UPDATE
			`bab_groups`
			SET
			`mail` = 'Y',
			`ustorage` = 'N',
			`notes` = 'Y',
			`contacts` = 'Y',
			`directory` = 'Y',
			`pcalendar` = 'Y',
			`id_ocentity` = '0'
			WHERE
			`id` = '".$babDB->db_escape_string($id_elv_group)."'
			");
			$id_group = $id_elv_group;
			$group_name = $name;
			$description = undecode_html(bab_translate("Directory for the group of pupils of the class", $GLOBALS['babAddonFolder']))." ".mb_strtoupper($class_name, CHARSET);
			$id_dgowner = $id_delegation;
			$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
			// Mise en place des droits sur l'annuaire
			// Droit pour les groupes des utilisateurs du niveau <niveau> : Voir
			// Droit pour le groupe des gestionnaires du niveau <niveau>Gest : Ajouter, Supprimer, Importer, Exporter
			set_right_on_directory($id_directory, "view", $id_delegated_group);
			set_right_on_directory($id_directory, "add", $id_gest_group);
			set_right_on_directory($id_directory, "del", $id_gest_group);
			set_right_on_directory($id_directory, "import", $id_gest_group);
			set_right_on_directory($id_directory, "export", $id_gest_group);

			// Cration du groupe des enseignants de la classe
			$name = $class_name.TEACHERS_GROUP_SUFFIX;
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			UPPER(`name`) = UPPER('".$babDB->db_escape_string($name)."')
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$description = undecode_html(bab_translate("Group for the teachers of the class", $GLOBALS['babAddonFolder']))." ".mb_strtoupper($class_name, CHARSET);
				$managerid = $GLOBALS["BAB_SESS_USERID"];
				$parent = $id_delegated_group;
				$id_prof_group = bab_createGroup( $name, $description, $managerid, $parent);
			}
			else
			{
				$temp= $babDB->db_fetch_array($res);
				$id_prof_group = $temp["id"];
				$is_existing_class = true;
			}
			$id_group = $id_prof_group;
			// Cration de l'annuaire sur le groupe des enseignants de la classe
			$res = $babDB->db_query("
			UPDATE
			`bab_groups`
			SET
			`mail` = 'Y',
			`ustorage` = 'N',
			`notes` = 'Y',
			`contacts` = 'Y',
			`directory` = 'Y',
			`pcalendar` = 'Y',
			`id_ocentity` = '0'
			WHERE
			`id` = '".$babDB->db_escape_string($id_prof_group)."'
			");
			$id_group = $id_prof_group;
			$group_name = $name;
			$description = undecode_html(bab_translate("Directory for the group of teachers of the class", $GLOBALS['babAddonFolder']))." ".mb_strtoupper($class_name, CHARSET);
			$id_dgowner = $id_delegation;
			$id_directory = create_directory($id_group, $group_name, $description, $id_dgowner);
			// Mise en place des droits sur l'annuaire
			// Droit pour les groupes des utilisateurs du niveau <niveau> : Voir
			// Droit pour le groupe des gestionnaires du niveau <niveau>Gest : Ajouter, Supprimer, Importer, Exporter
			set_right_on_directory($id_directory, "view", $id_delegated_group);
			set_right_on_directory($id_directory, "add", $id_gest_group);
			set_right_on_directory($id_directory, "del", $id_gest_group);
			set_right_on_directory($id_directory, "import", $id_gest_group);
			set_right_on_directory($id_directory, "export", $id_gest_group);

			// Cration du schma d'approbation associ  la classe
			$name = $class_name.FLOW_APPROVERS_SUFFIX ;
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_flow_approvers`
			WHERE
			UPPER(`name`) = UPPER('".$babDB->db_escape_string($name)."')
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$formula = $id_gest_group."|".$id_prof_group;
				$res = $babDB->db_query("
				INSERT INTO
				`bab_flow_approvers`
				(
				`name`,
				`formula`,
				`id_dgowner`,
				`satype`
				)
				VALUES
				(
				'".$babDB->db_escape_string($name)."',
				'".$babDB->db_escape_string($formula)."',
				'".$babDB->db_escape_string($id_delegation)."',
				'2'
				)
				") ;
				$id_flow_approvers = $babDB->db_insert_id($res);
			}
			else
			{
				$temp = $babDB->db_fetch_array($res);
				$id_flow_approvers = $temp["id"];
			}
		}
		return (array("is_existing_class" => $is_existing_class, "id_delegated_group" => $id_delegated_group, "id_parent_group" => $id_parent_group, "id_delegation" => $id_delegation, "id_gest_group" => $id_gest_group, "id_elv_delegated_group" => $id_elv_delegated_group, "id_prof_delegated_group" => $id_prof_delegated_group, "id_elv_group" => $id_elv_group, "id_prof_group" => $id_prof_group, "id_flow_approvers" => $id_flow_approvers ));
	}
}

if (!function_exists('create_objects_in_class'))
{
	function create_objects_in_class($class_name, $class_variables_array)
	{
		global $babDB;
		$id_delegated_group = $class_variables_array["id_delegated_group"];
		$id_delegation = $class_variables_array["id_delegation"];
		$id_parent_group = $class_variables_array["id_parent_group"];
		$id_gest_group = $class_variables_array["id_gest_group"];
		$id_elv_delegated_group = $class_variables_array["id_elv_delegated_group"];
		$id_prof_delegated_group = $class_variables_array["id_prof_delegated_group"];
		$id_elv_group = $class_variables_array["id_elv_group"];
		$id_prof_group = $class_variables_array["id_prof_group"];
		$id_flow_approvers = $class_variables_array["id_flow_approvers"];
		
		// Agendas collectifs
		// Agenda collectif des enseignants de la classe
		$name = $class_name.TEACHERS_GROUP_SUFFIX;
		$description = undecode_html(bab_translate("Collective calendar for the teachers of the class", $GLOBALS['babAddonFolder']))." ".$class_name;
		$idsa = 0; //pas de modration
		$id_dgowner = $id_delegation;
		$id_calendar = create_public_calendar($name, $description, $idsa, $id_dgowner);
		// Droits pour le groupe des enseignants de la classe : Consulter, Grer, Groupe impact
		// Droit pour les gestionnaires du niveau : Consulter, Grer
		set_right_on_public_calendar($id_calendar, "view", $id_prof_group);
		set_right_on_public_calendar($id_calendar, "manage", $id_prof_group);
		set_right_on_public_calendar($id_calendar, "groups", $id_prof_group);
		set_right_on_public_calendar($id_calendar, "view", $id_gest_group);
		set_right_on_public_calendar($id_calendar, "manage", $id_gest_group);
		
		// Agenda collectif des lves de la classe
		$name = $class_name.STUDENTS_GROUP_SUFFIX ;
		$description = undecode_html(bab_translate("Collective calendar for the pupils of the class", $GLOBALS['babAddonFolder']))." ".$class_name;
		$idsa = $id_flow_approvers;
		$id_dgowner = $id_delegation;
		$id_calendar = create_public_calendar($name, $description, $idsa, $id_dgowner);
		// Droit pour le groupe des lves de la classe : Consulter, Groupe impact
		// Droits pour le groupe des enseignants de la classe : Consulter, Grer
		// Droit pour les gestionnaires du niveau : Consulter, Grer
		set_right_on_public_calendar($id_calendar, "view", $id_elv_group);
		set_right_on_public_calendar($id_calendar, "groups", $id_elv_group);
		set_right_on_public_calendar($id_calendar, "view", $id_prof_group);
		set_right_on_public_calendar($id_calendar, "manage", $id_prof_group);
		set_right_on_public_calendar($id_calendar, "view", $id_gest_group);
		set_right_on_public_calendar($id_calendar, "manage", $id_gest_group);
		
		// Catgorie de thmes de la classe
		// Identification de la catgorie de thmes parente
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_topics_categories`
		WHERE
		(`id_parent` = '0')
		AND
		(`id_dgowner` = '".$babDB->db_escape_string($id_delegation)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$name = mb_strtoupper($level);
			$description = "";
			$benabled = "N";
			$template = "template";
			$disptmpl = "default";
			$topcatid = 0;
			$dgowner = $id_delegation;
			$id_topcat = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_topcat = $temp["id"];
		}
		// Identification de la catgorie de thmes de la classe
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_topics_categories`
		WHERE
		(UPPER(`title`) = '".mb_strtoupper($class_name)."')
		AND
		(`id_parent` = '".$id_topcat."')
		AND
		(`id_dgowner` = '".$babDB->db_escape_string($id_delegation)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$name = mb_strtoupper($class_name);
			$description = "";
			$benabled = "N";
			$template = "template";
			$disptmpl = "default";
			$topcatid = $id_topcat;
			$dgowner = $id_delegation;
			$id_topcat = bab_addTopicsCategory($name, $description, $benabled, $template, $disptmpl, $topcatid, $dgowner);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_topcat = $temp["id"];
		}
		// Mise en place des droits par dfaut sur la catgorie de thmes de la classe
		// Suppresion de tous les droits hrits sur cette catgorie
		unset_def_right_on_topics_category($id_topcat, "view");
		unset_def_right_on_topics_category($id_topcat, "submit");
		unset_def_right_on_topics_category($id_topcat, "comment");
		unset_def_right_on_topics_category($id_topcat, "modifiy");
		unset_def_right_on_topics_category($id_topcat, "manage");
		// Mise en place des droits par dfaut sur les thmes de la catgorie
		// Droits pour les lves de la classe : Lire les articles, Soumettre des articles, Soumettre des commentaires
		// Droits pour les enseignants de la classe : Lire les articles, Soumettre des articles, Soumettre des commentaires, Modifier les articles
		// Droits pour les gestionnaire du  niveau : Lire les articles, Modifier les articles, Grer les articles
		set_def_right_on_topics_category($id_topcat, "view", $id_elv_group);
		set_def_right_on_topics_category($id_topcat, "submit", $id_elv_group);
		set_def_right_on_topics_category($id_topcat, "comment", $id_elv_group);
		set_def_right_on_topics_category($id_topcat, "view", $id_prof_group);
		set_def_right_on_topics_category($id_topcat, "submit", $id_prof_group);
		set_def_right_on_topics_category($id_topcat, "comment", $id_prof_group);
		set_def_right_on_topics_category($id_topcat, "modify", $id_prof_group);
		set_def_right_on_topics_category($id_topcat, "view", $id_gest_group);
		set_def_right_on_topics_category($id_topcat, "modify", $id_gest_group);
		set_def_right_on_topics_category($id_topcat, "manage", $id_gest_group);
		// Cration des thmes d'articles
		for ($j = 1; $j <= TOPICS_DEFAULT_NUMBER; $j++)
		{
			$topic_name = mb_strtoupper($class_name)." - ".undecode_html(bab_translate("Topic",  $GLOBALS['babAddonFolder']))." ".$j;
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_topics`
			WHERE
			(`category` = '".$topic_name."')
			AND
			(`id_cat` = '".$id_topcat."')
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$name = $topic_name;
				$description = "";
				$idCategory = $id_topcat;
				$topicArr = array();
				$topicArr["idsaart"] = $id_flow_approvers;
				$topicArr["idsacom"] = $id_flow_approvers;
				$topicArr["idsa_update"] = $id_flow_approvers;
				$topicArr["notify"] = "Y";
				$topicArr["lang"] = "fr";
				$topicArr["article_tmpl"] = "";
				$topicArr["display_tmpl"] = "";
				$topicArr["restrict_access"] = "Y";
				$topicArr["allow_hpages"] = "N";
				$topicArr["allow_pubdates"] = "N";
				$topicArr["allow_attachments"] = "N";
				$topicArr["allow_update"] = "1";
				$topicArr["allow_manupdate"] = "1";
				$topicArr["max_articles"] = 10;
				$topicArr["auto_approbation"] = "Y";
				$topicArr["busetags"] = "N";
				$topicArr["allow_unsubscribe"] = "1";
				$ClasseThemeTopicId = bab_addTopic($name, $description, $idCategory, $error, $topicArr);
			}
		}
		// Forum de la classe
		$name = mb_strtoupper($class_name);
		$description = undecode_html(bab_translate("Forum of the class",  $GLOBALS['babAddonFolder']))." ".$class_name;
		$id_dgowner = $id_delegation;
		$moderation = "Y";
		$notification = "N";
		$active = "Y";
		$id_forum = create_forum($name, $description, $id_dgowner, $moderation, $notification, $active);
		// Droits sur le forum
		// Droits pour les lves de la classe : Lire les contributions, Contribuer, Rpondre
		// Droits pour les enseignants de la classe : Lire les contributions, Contribuer, Rpondre
		// Droits pour les gestionnaires du niveau : Lire les contributions, Grer le forum
		if (!is_null($id_forum))
		{
			set_right_on_forum($id_forum, "view", $id_elv_group);
			set_right_on_forum($id_forum, "post", $id_elv_group);
			set_right_on_forum($id_forum, "reply", $id_elv_group);
			set_right_on_forum($id_forum, "view", $id_prof_group);
			set_right_on_forum($id_forum, "post", $id_prof_group);
			set_right_on_forum($id_forum, "reply", $id_prof_group);
			set_right_on_forum($id_forum, "view", $id_gest_group);
			set_right_on_forum($id_forum, "manage", $id_gest_group);
		}

		// Gestionnaire de fichiers
		// Cration du dossier de la classe
		$folder = mb_strtoupper($class_name);
		$id_dgowner = $id_delegation;
		$relative_path = "";
		$bhide = "N"; // prsent dans le gestionnaire de fichiers
		$idsa = 0; // pas de modration
		$auto_approbation = "Y"; // autoapprobation
		$filenotify = "N"; // pas de notification
		$id_folder = create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $auto_approbation, $filenotify);
		// Droits pour les lves de la classe : Dposer, Tlcharger,
		// Droits pour les enseignants de la classe : Dposer, Tlcharger, Mettre  jour
		// Droits pour les gestionnaire du niveau : Tlcharger, Mettre  jour, Grer
		if (!is_null($id_folder))
		{
			set_right_on_folder($id_folder, "upload", $id_elv_group);
			set_right_on_folder($id_folder, "download", $id_elv_group);
			set_right_on_folder($id_folder, "upload", $id_prof_group);
			set_right_on_folder($id_folder, "download", $id_prof_group);
			set_right_on_folder($id_folder, "update", $id_prof_group);
			set_right_on_folder($id_folder, "download", $id_gest_group);
			set_right_on_folder($id_folder, "update", $id_gest_group);
			set_right_on_folder($id_folder, "manage", $id_gest_group);
		}

		// Gestionnaire de tches
		// Cration de l'espace de projets de la classe
		$name = mb_strtoupper($class_name);
		$id_dgowner = $id_delegation;
		$id_projects_space = create_projects_space($name, $id_dgowner);
		// Mise en place des droits par dfaut sur l'espace de projets cr
		if (!is_null($id_projects_space)) set_default_rights_on_projects_space($id_projects_space, $id_elv_group, $id_prof_group);
	}
}

if (!function_exists('ordinal'))
{
	function ordinal($n)
	{
		switch($n)
		{
			case '':
				return;
			case 1:
				return ($n.bab_translate("st", $GLOBALS['babAddonFolder']));
				break;
			case 2:
				return ($n.bab_translate("nd", $GLOBALS['babAddonFolder']));
				break;
			case 3:
				return ($n.bab_translate("rd", $GLOBALS['babAddonFolder']));
				break;
			default:
				return ($n.bab_translate("th", $GLOBALS['babAddonFolder']));
		}
	}
}

if (!function_exists('FindFlowApproverIdFromName'))
{
	function FindFlowApproverIdFromName($name, $id_dgowner)
	{
		global $babDB;
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_flow_approvers` 
		WHERE (UPPER(`name`) = UPPER('".$babDB->db_escape_string($name)."'))
		AND
		(`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			return(false);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			return($temp["id"]);
		}
	}
}

if (!function_exists('FindGroupIdFromName'))
{
	function FindGroupIdFromName($group_name, $id_parent)
	{
		global $babDB;
		$res = $babDB->db_query("
		SELECT 
		`id` 
		FROM 
		`bab_groups` 
		WHERE 
		(UPPER(`name`) = UPPER('".$babDB->db_escape_string($group_name)."')) 
		AND 
		(`id_parent` = '".$babDB->db_escape_string($id_parent)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			return(false);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			return($temp["id"]);
		}
	}
}

if (!function_exists('FindParentIdGroupFromId'))
{
	function FindParentIdGroupFromId($id_group)
	{
		global $babDB;
		$res = $babDB->db_query("
		SELECT
		`id_parent`
		FROM
		`bab_groups`
		WHERE
		`id` = '".$babDB->db_escape_string($id_group)."'
		");
		if ($babDB->db_num_rows($res) > 0)
		{
			$temp = $babDB->db_fetch_array($res);
			return ($temp['id_parent']);
		}
		else
		{
			return (NULL);
		}
	}
}

if (!function_exists('FindIdGroupAndChildren'))
{
	function FindIdGroupAndChildren($id_group)
	{
		return($id_group + BAB_ACL_GROUP_TREE);
	}
}

if (!function_exists('create_directory'))
{
	function create_directory($id_group, $group_name, $description, $id_dgowner)
	{
		global $babDB;

		$name = $group_name;
		$res = $babDB->db_query(
		"UPDATE `bab_groups`
		SET
		`directory` = 'Y'
		WHERE
		`id` = '".$babDB->db_escape_string($id_group)."'");
		$res = $babDB->db_query(
		"SELECT `id`
		FROM `bab_db_directories`
		WHERE `id_group` = '".$babDB->db_escape_string($id_group)."'");
		if (!$res || $babDB->db_num_rows($res) == 0)
		{
			$name = $group_name;
			$res = $babDB->db_query(
			"INSERT INTO `bab_db_directories`(
			`name`,
			`description`,
			`id_group`,
			`id_dgowner`)
			VALUES (
			'".$babDB->db_escape_string($name)."',
			'".$babDB->db_escape_string($description)."',
			'".$babDB->db_escape_string($id_group)."',
			'".$babDB->db_escape_string($id_dgowner)."')");
			$id_directory = $babDB->db_insert_id($res);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_directory = $temp["id"];
			$babDB->db_query("
			UPDATE `bab_db_directories`
			SET
			`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."',
			`name` = '".$babDB->db_escape_string($name)."',
			`description` = '".$babDB->db_escape_string($description)."'
			WHERE `id_group` = '".$babDB->db_escape_string($id_group)."'");
		}
		return $id_directory;
	}
}

if (!function_exists('set_right_on_directory'))
{
	function set_right_on_directory($id_directory, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "add":
				$table = "bab_dbdiradd_groups";
				break;
			case "bind":
				$table = "bab_dbdirbind_groups";
				break;
			case "del":
				$table = "bab_dbdirdel_groups";
				break;
			case "empty":
				$table = "bab_dbdirempty_groups";
				break;
			case "export":
				$table = "bab_dbdirexport_groups";
				break;
			case "import":
				$table = "bab_dbdirimport_groups";
				break;
			case "unbind":
				$table = "bab_dbdirunbind_groups";
				break;
			case "update":
				$table = "bab_dbdirupdate_groups";
				break;
			case "view":
				$table = "bab_dbdirview_groups";
				break;
			default:
				$table = "";
				break;
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("SELECT `id` FROM `".$table ."` WHERE `id_object` = ".$id_directory." AND `id_group` = ".$id_group);
			if ($babDB->db_num_rows($res) == 0)
			{
				$res= $babDB->db_query("INSERT INTO `".$table."`(`id_object`, `id_group`) VALUES (".$id_directory.", ".$id_group.")");
			}
		}
	}
}

if (!function_exists('create_folder'))
{
	function create_folder($folder, $id_dgowner, $relative_path, $bhide, $idsa, $auto_approbation, $filenotify)
	{
		global $babDB;
		$substitution_pattern = array_keys($GLOBALS["babFileNameTranslation"]);
		for ($i = 0; $i < count($GLOBALS["babFileNameTranslation"]); $i++)
		{
			$search	= $substitution_pattern[$i];
			$replace = $GLOBALS["babFileNameTranslation"][$search];
			$name = str_replace($search, $replace, $folder);
		}
		$res = $babDB->db_query("
		SELECT `id`
		FROM `bab_fm_folders`
		WHERE
			UPPER(`folder`) = UPPER('".$babDB->db_escape_string($folder)."')
			AND `id_dgowner` = ".$id_dgowner."
			AND `sRelativePath` = '".$babDB->db_escape_string($relative_path)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO `bab_fm_folders`
			(`folder`,
			`sRelativePath`,
			`manager`,
			`idsa`,
			`filenotify`,
			`active`,
			`version`,
			`id_dgowner`,
			`bhide`,
			`auto_approbation`,
			`baddtags`,
			`bcap_downloads`,
			`max_downloads`,
			`bdownload_history`)
			VALUES
			('".$babDB->db_escape_string($folder)."',
			'".$babDB->db_escape_string($relative_path)."',
			0,
			'".$babDB->db_escape_string($idsa)."',
			'".$babDB->db_escape_string($filenotify)."',
			'Y',
			'Y',
			'".$babDB->db_escape_string($id_dgowner)."',
			'".$babDB->db_escape_string($bhide)."',
			'".$babDB->db_escape_string($auto_approbation)."',
			'N',
			'N',
			0,
			'Y')
			");
			$id_folder = $babDB->db_insert_id($res);

			$res = $babDB->db_query("SELECT `uploadpath` FROM `bab_sites` WHERE `name` = '".$babDB->db_escape_string($GLOBALS["babSiteName"])."'");
			$temp = $babDB->db_fetch_array($res);
			$uploadpath = $temp["uploadpath"];
			if (!file_exists($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner)) mkdir($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner);
			if (!file_exists($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$relative_path)) mkdir($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$reltive_path);
			if (!file_exists($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$relative_path.DIRECTORY_SEPARATOR.$name)) mkdir($uploadpath.DIRECTORY_SEPARATOR."fileManager".DIRECTORY_SEPARATOR."collectives".DIRECTORY_SEPARATOR."DG".$id_dgowner.DIRECTORY_SEPARATOR.$relative_path.DIRECTORY_SEPARATOR.$name);

			return $id_folder;
		}
		else
		{
			return NULL;
		}
	}
}


if (!function_exists('set_right_on_folder'))
{
	function set_right_on_folder($id_folder, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "upload":
				$table = "bab_fmupload_groups";
				break;
			case "download":
				$table = "bab_fmdownload_groups";
				break;
			case "update":
				$table = "bab_fmupdate_groups";
				break;
			case "manage":
				$table = "bab_fmmanagers_groups";
				break;
			case "notify":
				$table = "bab_fmnotify_groups";
				break;
			case "unzip":
				$table = "bab_fmunzip_groups";
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("SELECT `id` FROM `".$table ."` WHERE `id_object` = '".$babDB->db_escape_string($id_folder)."' AND `id_group` = '".$babDB->db_escape_string($id_group)."'");
			if ($babDB->db_num_rows($res) == 0)
			{
				$res= $babDB->db_query("INSERT INTO `".$table."`(`id_object`, `id_group`) VALUES ('".$babDB->db_escape_string($id_folder)."', '".$babDB->db_escape_string($id_group)."')");
			}
		}
	}
}

if (!function_exists('transfert_right_on_folder'))
{
	function transfert_right_on_folder($id_folder, $right, $id_old_group, $id_new_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "upload":
				$table = "bab_fmupload_groups";
				break;
			case "download":
				$table = "bab_fmdownload_groups";
				break;
			case "update":
				$table = "bab_fmupdate_groups";
				break;
			case "manage":
				$table = "bab_fmmanagers_groups";
				break;
			case "notify":
				$table = "bab_fmnotify_groups";
				break;
			case "unzip":
				$table = "bab_fmunzip_groups";
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("
			UPDATE 
			`".$table ."` 
			SET 
			`id_group` = '".$babDB->db_escape_string($id_new_group)."' 
			WHERE 
			`id_object` = '".$babDB->db_escape_string($id_folder)."' 
			AND 
			`id_group` = '".$babDB->db_escape_string($id_old_group)."'
			");
		}
	}
}

if (!function_exists('set_def_right_on_topics_category'))
{
	function set_def_right_on_topics_category($id_topcat, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "comment":
				$table = "bab_def_topcatcom_groups";
				break;
			case "manage":
				$table = "bab_def_topcatman_groups";
				break;
			case "modify":
				$table = "bab_def_topcatmod_groups";
				break;
			case "submit":
				$table = "bab_def_topcatsub_groups";
				break;
			case "view":
				$table = "bab_def_topcatview_groups";
				break;
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("
			SELECT 
			`id` 
			FROM 
			`".$table ."` 
			WHERE 
			`id_object` = '".$babDB->db_escape_string($id_topcat)."' 
			AND 
			`id_group` = '".$babDB->db_escape_string($id_group)."'
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$res= $babDB->db_query("
				INSERT INTO 
				`".$table."`
				(
				`id_object`, 
				`id_group`
				)
				VALUES 
				(
				'".$babDB->db_escape_string($id_topcat)."', 
				'".$babDB->db_escape_string($id_group)."'
				)
				");
			}
		}
	}
}


if (!function_exists('unset_def_right_on_topics_category'))
{
	function unset_def_right_on_topics_category($id_topcat,$right)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "comment":
				$table = "bab_def_topcatcom_groups";
				break;
			case "manage":
				$table = "bab_def_topcatman_groups";
				break;
			case "modify":
				$table = "bab_def_topcatmod_groups";
				break;
			case "submit":
				$table = "bab_def_topcatsub_groups";
				break;
			case "view":
				$table = "bab_def_topcatview_groups";
				break;
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res= $babDB->db_query("
			DELETE FROM 
			`".$table."` 
			WHERE 
			`id_object` = '".$babDB->db_escape_string($id_topcat)."'
			");
		}
	}
}

if (!function_exists('set_right_on_topic'))
{
	function set_right_on_topic($id_topic, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch($right)
		{
			case "view":
				$table = "bab_topicsview_groups";
				break;
			case "submit":
				$table = "bab_topicssub_groups";
				break;
			case "comment":
				$table = "bab_topicscom_groups";
				break;
			case "modify":
				$table = "bab_topicsmod_groups";
				break;
			case "manage":
				$table = "bab_topicsman_groups";
				break;
			default:
				$table = "";
				break;
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("
			SELECT 
			`id` 
			FROM 
			`".$table."` 
			WHERE 
			id_object = '".$babDB->db_escape_string($id_topic)."'
			AND 
			id_group = '".$babDB->db_escape_string($id_group)."'
			");
			if ($babDB->db_num_rows($res) === 0)
			{
				$res = $babDB->db_query("
				INSERT INTO 
				`".$table."` 
				(
				`id_object`,
				`id_group`) 
				VALUES 
				(
				'".$babDB->db_escape_string($id_topic)."', 
				'".$babDB->db_escape_string($id_group)."'
				)
				");
			}
		}
	}
}

if (!function_exists('create_forum'))
{
	function create_forum($name, $description, $id_dgowner, $moderation, $notification, $active)
	{
		global $babBody;
		global $babDB;

		$managerid = $GLOBALS["BAB_SESS_USERID"];

		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_forums`
		WHERE
		`name` = '".$babDB->db_escape_string($name)."'
		");
		if( $babDB->db_num_rows($res) === 0)
		{
			$res = $babDB->db_query("select max(ordering) from `bab_forums`");
			if( $res )
			{
				$arr = $babDB->db_fetch_array($res);
				$max = $arr[0] + 1;
			}
			else
			{
				$max = 0;
			}
			$nbmsgdisplay = 20;
			$bdisplayemailaddress = "N";
			$bdisplayauhtordetails = "N";
			$bflatview = "Y";
			$bupdatemoderator = "Y";
			$bupdateauthor = "N";

			$res = $babDB->db_query("
			INSERT INTO `bab_forums` (
			`name`,
			`description`,
			`display`,
			`moderation`,
			`notification`,
			`active`,
			`ordering`,
			`id_dgowner`,
			`bdisplayemailaddress`,
			`bdisplayauhtordetails`,
			`bflatview`,
			`bupdatemoderator`,
			`bupdateauthor`
			)
			VALUES(
			'" . $babDB->db_escape_string($name). "',
			'" . $babDB->db_escape_string($description). "',
			'" . $babDB->db_escape_string($nbmsgdisplay). "',
			'" . $babDB->db_escape_string($moderation). "',
			'" . $babDB->db_escape_string($notification). "',
			'" . $babDB->db_escape_string($active). "',
			'" . $babDB->db_escape_string($max). "',
			'" . $babDB->db_escape_string($id_dgowner). "',
			'" . $babDB->db_escape_string($bdisplayemailaddress). "',
			'" . $babDB->db_escape_string($bdisplayauhtordetails). "',
			'" . $babDB->db_escape_string($bflatview). "',
			'" . $babDB->db_escape_string($bupdatemoderator). "',
			'" . $babDB->db_escape_string($bupdateauthor). "'
			)
			");

			$id = $babDB->db_insert_id($res);

			return $id;
		}
		else
		{
			return NULL;
		}
	}
}

if (!function_exists('set_right_on_forum'))
{
	function set_right_on_forum($id_forum, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "files":
				$table = "bab_forumsfiles_groups";
				break;
			case "manage":
				$table = "bab_forumsman_groups";
				break;
			case "notify":
				$table = "bab_forumsnotify_groups";
				break;
			case "post":
				$table = "bab_forumspost_groups";
				break;
			case "reply":
				$table = "bab_forumsreply_groups";
				break;
			case "view":
				$table = "bab_forumsview_groups";
				break;
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("SELECT `id` FROM `".$table ."` WHERE `id_object` = ".$id_forum." AND `id_group` = ".$id_group);
			if ($babDB->db_num_rows($res) == 0)
			{
				$res= $babDB->db_query("INSERT INTO `".$table."`(`id_object`, `id_group`) VALUES (".$id_forum.", ".$id_group.")");
			}
		}
	}
}

if (!function_exists('create_public_calendar'))
{
	function create_public_calendar($name, $description, $idsa, $id_dgowner)
	{
		global $babDB;
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_cal_public`
		WHERE
		(`name` = '".$babDB->db_escape_string($name)."')
		AND
		(`id_dgowner` = '".$babDB->db_escape_string($id_dgowner)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO `bab_cal_public`
			(
			`name`,
			`description`,
			`id_dgowner`,
			`idsa`
			)
			VALUES
			(
			'".$name."',
			'".$description."',
			'".$id_dgowner."',
			'".$idsa."'
			)"
			);
			$id_public_calendar = $babDB->db_insert_id($res);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_public_calendar = $temp["id"];
		}
		$res = $babDB->db_query("SELECT `id` FROM `bab_calendar` WHERE (`owner` = '".$id_public_calendar."') AND (type = '".BAB_CAL_PUB_TYPE."')");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("INSERT INTO `bab_calendar` (owner, actif, type) VALUES ('".$id_public_calendar."', 'Y', '".BAB_CAL_PUB_TYPE."')");
			$id_calendar = $babDB->db_insert_id($res);
		}
		else
		{
			$temp = $babDB->db_fetch_array($res);
			$id_calendar = $temp["id"];
		}
		return ($id_calendar);
	}
}

if (!function_exists('set_right_on_public_calendar'))
{
	function set_right_on_public_calendar($id_calendar, $right, $id_group)
	{
		global $babDB;
		require_once( $GLOBALS['babInstallPath']."utilit/upgradeincl.php");
		switch ($right)
		{
			case "groups":
				$table = "bab_cal_pub_grp_groups";
				break;
			case "manage":
				$table = "bab_cal_pub_man_groups";
				break;
			case "view":
				$table = "bab_cal_pub_view_groups";
				break;
			default:
				$table = "";
		}
		if (($table != "") && (bab_isTable($table)))
		{
			$res = $babDB->db_query("SELECT `id` FROM `".$table ."` WHERE `id_object` = ".$id_calendar." AND `id_group` = ".$id_group);
			if ($babDB->db_num_rows($res) == 0)
			{
				$res= $babDB->db_query("INSERT INTO `".$table."`(`id_object`, `id_group`) VALUES (".$id_calendar.", ".$id_group.")");
			}
		}
	}
}

if (!function_exists('create_projects_space'))
{
	function create_projects_space($name, $id_dgowner)
	{
		global $babDB;
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_projects_spaces`
		WHERE
		(UPPER(`name`) = UPPER('".$babDB->db_escape_string($name)."'))
		AND
		(`idDelegation` = '".$babDB->db_escape_string($id_dgowner)."');
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			SELECT
			`id_user`
			FROM
			`bab_dg_admin`
			WHERE
			`id_dg` = '".$babDB->db_escape_string($id_dgowner)."'
			");
			if ($babDB->db_num_rows($res) == 0)
			{
				$id_user = $GLOBALS['BAB_SESS_USERID'];
			}
			else
			{
				$temp = $babDB->db_fetch_array($res);
				$id_user = $temp["id_user"];
			}
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_projects_spaces`
			(
			`idDelegation`,
			`name`,
			`description`,
			`idUserCreated`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_dgowner)."',
			'".$babDB->db_escape_string($name)."',
			'',
			'".$babDB->db_escape_string($id_user)."'
			)
			");
			$id_projects_space = $babDB->db_insert_id($res);
			return ($id_projects_space);
		}
		else
		{
			return (NULL);
		}
	}
}

if (!function_exists('set_default_rights_on_projects_space'))
{
	function set_default_rights_on_projects_space($id_projects_space, $id_elv_group, $id_prof_group)
	{
		global $babDB;
		// Utilisateurs autoriss  crer des projets : enseignants -> bab_tskmgr_project_creator_groups
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_project_creator_groups`
		WHERE
		(`id_object` = '".$babDB->db_escape_string($id_projects_space)."')
		AND
		(`id_group` = '".$babDB->db_escape_string($id_prof_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_project_creator_groups`
			(
			`id_object`,
			`id_group`
			) VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'".$babDB->db_escape_string($id_prof_group)."'
			)
			");
		}
		// Utilisateurs gestionnaires par dfaut : enseignants -> bab_tskmgr_default_projects_managers_groups
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_default_projects_managers_groups`
		WHERE
		(`id_object` = '".$babDB->db_escape_string($id_projects_space)."')
		AND
		(`id_group` = '".$babDB->db_escape_string($id_prof_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_default_projects_managers_groups`
			(
			`id_object`,
			`id_group`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'".$babDB->db_escape_string($id_prof_group)."'
			)
			");
		}
		// Superviseurs de projets par dfaut : enseignants -> bab_tskmgr_default_projects_supervisors_groups
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_default_projects_supervisors_groups`
		WHERE
		(`id_object` = '".$babDB->db_escape_string($id_projects_space)."')
		AND
		(`id_group` = '".$babDB->db_escape_string($id_prof_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query(
			"INSERT INTO 
			`bab_tskmgr_default_projects_supervisors_groups` 
			(
			`id_object`, 
			`id_group`
			) 
			VALUES 
			(
			'".$babDB->db_escape_string($id_projects_space)."', 
			'".$babDB->db_escape_string($id_prof_group)."'
			)
			");
		}
		// Visualiseurs de projet par dfaut : lves et enseignants -> bab_tskmgr_default_projects_visualizers_groups
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_default_projects_visualizers_groups`
		WHERE
		(`id_object` = '".$babDB->db_escape_string($id_projects_space)."')
		AND
		(`id_group` = '".$babDB->db_escape_string($id_elv_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_default_projects_visualizers_groups`
			(
			`id_object`,
			`id_group`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'".$babDB->db_escape_string($id_elv_group)."'
			)
			");
		}
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_default_projects_visualizers_groups`
		WHERE
		(`id_object` = '".$babDB->db_escape_string($id_projects_space)."')
		AND
		(`id_group` = '".$babDB->db_escape_string($id_prof_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_default_projects_visualizers_groups`
			(
			`id_object`,
			`id_group`
			) VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'".$babDB->db_escape_string($id_prof_group)."'
			)
			");
		}
		// Responsables de tche par dfaut : enseignants -> bab_tskmgr_default_task_responsible_groups
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_default_task_responsible_groups`
		WHERE
		(`id_object` = '".$babDB->db_escape_string($id_projects_space)."')
		AND
		(`id_group` = '".$babDB->db_escape_string($id_prof_group)."')
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_default_task_responsible_groups`
			(
			`id_object`, 
			`id_group`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'".$babDB->db_escape_string($id_prof_group)."'
			)
			");
		}
		// Configuration par dfaut des projets : bab_tskmgr_default_projects_configuration (id  idProjectSpace  tskUpdateByMgr  endTaskReminder  tasksNumerotation  emailNotice  faqUrl)
		// Dlgation de mise  jour des tches aux responsables : oui
		// Dlai d'alerte : 5 jours
		// Numrotation des tches : squentiel (automatique)
		// Notification email : Non <!>
		// Lien pour l'aide : <vide>
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_default_projects_configuration`
		WHERE
		`idProjectSpace` = '".$babDB->db_escape_string($id_projects_space)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_default_projects_configuration`
			(
			`idProjectSpace`, 
			`tskUpdateByMgr`,
			`endTaskReminder`,
			`tasksNumerotation`,
			`emailNotice`,
			`faqUrl`
			) VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'1',
			'5',
			'1',
			'0',
			''
			)
			");
		}
		// Dfinition des vnments de notifications : bab_tskmgr_notice (idProjectSpace idProject profil idEvent )
		// Projet cr	: Superviseur
		// Projet supprim : Superviseur
		// Tche cre : Responsable
		// Tche mise  jour par le gestionnaire : Responsable
		// Tche mise  jour par le responsable : Gestionnaire
		// Tche supprime : Responsable
		// Alerte par notifications : Responsable
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_tskmgr_notice`
		WHERE
		`idProjectSpace` = '".$babDB->db_escape_string($id_projects_space)."'
		");
		if ($babDB->db_num_rows($res) == 0)
		{
			$res = $babDB->db_query("
			INSERT INTO
			`bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES
			(
			'".$babDB->db_escape_string(
			$id_projects_space)."',
			'0',
			'0',
			'0'
			)
			");
			$res = $babDB->db_query("
			INSERT INTO `bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES (
			'".$babDB->db_escape_string($id_projects_space)."',
			'0',
			'0',
			'1'
			)
			");
			$res = $babDB->db_query("
			INSERT INTO `bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'0',
			'2',
			'2'
			)
			");
			$res = $babDB->db_query("
			INSERT INTO `bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'0',
			'2',
			'3'
			)
			");
			$res = $babDB->db_query("
			INSERT INTO `bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'0',
			'1',
			'4'
			)
			");
			$res = $babDB->db_query("
			INSERT INTO `bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'0',
			'2',
			'5'
			)
			");
			$res = $babDB->db_query("
			INSERT INTO `bab_tskmgr_notice`
			(
			`idProjectSpace`,
			`idProject`,
			`profil`,
			`idEvent`
			)
			VALUES
			(
			'".$babDB->db_escape_string($id_projects_space)."',
			'0',
			'2',
			'6'
			)
			");
		}
	}
}

if (!function_exists('is_existing_personal_group_and_personal_shared_folder'))
{
	function is_existing_personal_group_and_personal_shared_folder($id_user, $id_delegated_group)
	{
		global $babDB;
		// Recherche de l'existance du groupe personnel partag
		$personal_group_id = NULL;
		$personal_shared_folder_id = NULL;
		$res = $babDB->db_query("
		SELECT
		`nickname`,
		`lastname`,
		`firstname`
		FROM
		`bab_users`
		WHERE
		`id` = '".$babDB->db_escape_string($id_user)."'
		");
		$arr = $babDB->db_fetch_array($res);
		$nickname = $arr['nickname'];
		$lastname = $arr['lastname'];
		$firstname = $arr['firstname'];
		$personnal_group_name = $nickname.' '.$lastname.' '.$firstname;
		$res = $babDB->db_query("
		SELECT
		`id`
		FROM
		`bab_groups`
		WHERE 
		`name` = '".$babDB->db_escape_string($personnal_group_name)."'
		AND
		`id_parent` = '".$babDB->db_escape_string($id_delegated_group)."'
		");
		if ($babDB->db_num_rows($res) === 0)
		{
			$personnal_group_name = replaceInvalidCharactersInName(trim($nickname)).' '.replaceInvalidCharactersInName(trim($lastname)).' '.replaceInvalidCharactersInName(trim($firstname));
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE 
			`name` = '".$babDB->db_escape_string($personnal_group_name)."'
			AND
			`id_parent` = '".$babDB->db_escape_string($id_delegated_group)."'
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$arr = $babDB->db_fetch_array($res);
				$personal_group_id = $arr['id'];
			}
		}
		else
		{
			$arr = $babDB->db_fetch_array($res);
			$personal_group_id = $arr['id'];
		}
		// Recherche de l'existence du rpertoire personnel partag
		if (!is_null($personal_group_id))
		{
			$res = $babDB->db_query("
			SELECT
			`bab_fm_folders`.`id`
			FROM
			`bab_fm_folders`,
			`bab_dg_groups`
			WHERE
			`folder` = '".$babDB->db_escape_string($personnal_group_name)."'
			AND
			`sRelativePath` = ''
			AND
			`id_dgowner` = `bab_dg_groups`.`id`
			AND
			`id_group`	='".$babDB->db_escape_string($id_delegated_group)."'
			");
			if ($babDB->db_num_rows($res) > 0)
			{
				$arr = $babDB->db_fetch_array($res);
				$personal_shared_folder_id = $arr['id'];
			}
		}
		return(array($personal_group_id , $personal_shared_folder_id));
	}
}

?>
