<?php

require_once 'base.php';
require_once $GLOBALS['babAddonPhpPath'].'gestutilisateurs_ini.php';
require_once $GLOBALS['babAddonPhpPath'].'import_inc.php';
require_once $GLOBALS['babInstallPath'].'utilit/artapi.php';

// Compte_rendu de cration des comptes par importation de liste .CSV pour les lyces d'enseignement professionnel 
// ou 2es sections de techniciens suprieurs (organisation en promotion)
function display_promotions_report_form()
{
	global $babBody;
	global $csv_import_users_array;
	// Augmentation du temps d'excution maximale pour l'importation (port  600 s soit 10 min.)
	ini_set('max_execution_time', '600');
	class display_promotions_report_form_class
	{
		function display_promotions_report_form_class($csv_import_users_array)
		{
			global $babBody;
			global $babDB;
			
			require_once $GLOBALS['babInstallPath'].'admin/register.php';
			
			$idx = bab_rp('idx', 'LGT');
			
			$this->group_id = bab_pp('promo', 1);
			
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			UPPER(`name`) = UPPER('".$babDB->db_escape_string(ucfirst($idx).STUDENTS_GROUP_SUFFIX)."')
			AND
			`id_parent` = '".$babDB->db_escape_string(STUDENTS_GROUP_ID)."'
			");
			if ($babDB->db_num_rows($res) === 0)
			{
				$babBody->addError(undecode_html(bab_translate("Error when data processing!", $GLOBALS['babAddonFolder'])));
				return;
			}
			$arr = $babDB->db_fetch_array($res);
			$this->type_ens_groupe_id = $arr['id'];
			
			$res = $babDB->db_query("
			SELECT
			`bg1`.`name`,
			`bg1`.`id_parent` AS `parent_group_id`,
			`bg2`.`id_parent` AS `grand_parent_group_id`
			FROM
			`bab_groups` AS `bg1`,
			`bab_groups` AS `bg2`
			WHERE
			`bg1`.`id` = '".$babDB->db_escape_string($this->group_id)."'
			AND
			`bg2`.`id` = `bg1`.`id_parent`
			");
			if ($babDB->db_num_rows($res) === 0)
			{
				$babBody->addError(undecode_html(bab_translate("Error when data processing!", $GLOBALS['babAddonFolder'])));
				return;
			}
			$arr = $babDB->db_fetch_array($res);
			$name = $arr['name'];
			$this->entity = mb_substr($name, 0, mb_strlen($name) - mb_strlen(STUDENTS_GROUP_SUFFIX), CHARSET);
			$this->parent_group_id = $arr['parent_group_id'];
			$this->grand_parent_group_id = $arr['grand_parent_group_id'];
			
			$this->csv_import_users_array = $csv_import_users_array;
			$this->count = count($this->csv_import_users_array);
			$this->entity_label = undecode_html(bab_translate("Promotion", $GLOBALS['babAddonFolder']));
			$this->lastname_label = undecode_html(bab_translate("Lastname", $GLOBALS['babAddonFolder']));
			$this->firstname_label = undecode_html(bab_translate("Firstname", $GLOBALS['babAddonFolder']));
			$this->email_label = undecode_html(bab_translate("Email", $GLOBALS['babAddonFolder']));
			$this->nickname_label = undecode_html(bab_translate("Nickname", $GLOBALS['babAddonFolder']));
			$this->password_label = undecode_html(bab_translate("Password", $GLOBALS['babAddonFolder']));
			$this->notes_label = undecode_html(bab_translate("Notes", $GLOBALS['babAddonFolder']));
			$this->import_new_list_url = $GLOBALS['babAddonUrl'].'import';
			$this->import_new_list_button_label = undecode_html(bab_translate("Import a new users list", $GLOBALS['babAddonFolder']));
			$this->img_print_src = $GLOBALS['babInstallPath']."skins/ovidentia/images/addons/".$GLOBALS['babAddonFolder']."/print.png";
			$this->print_label = undecode_html(bab_translate("Print", $GLOBALS['babAddonFolder']));
			$this->bgcolor = false;
		}
		
		function next()
		{
			global $babBody;
			global $babDB;
			
			static $k=0;
			if( $k < $this->count)
			{
				$this->bgcolor = !$this->bgcolor;
				$this->lastname = undecode_html(mb_strtoupper($this->csv_import_users_array[$k]['lastname'], CHARSET));
				$this->firstname = undecode_html(mb_convert_case($this->csv_import_users_array[$k]['firstname'], MB_CASE_TITLE, CHARSET));
				$this->login = $this->csv_import_users_array[$k]['login'];
				$mail_domain = bab_rp('mail_domain', DEFAULT_MAIL_DOMAIN_VALUE);
				if (empty($mail_domain))
				{
					$this->email = DEFAULT_MAIL;
				}
				else
				{
					$this->email = $this->login.'@'.$mail_domain;
				}
				$this->password = $this->csv_import_users_array[$k]['password'];
				list($this->user_id, $this->nickname, $this->password) = get_user_id_and_pwd($this->lastname, $this->firstname, $this->email, $this->login, $this->password);
				$this->notes = undecode_html(bab_translate("New account", $GLOBALS['babAddonFolder']));
				
				if ($this->password == 'NC')
				{
					$this->notes = undecode_html(bab_translate("Existing account", $GLOBALS['babAddonFolder']));
					$info_array = bab_getUserInfos($this->user_id);
					if (($info_array['disabled'] == 1 ) || ($info_array['is_confirmed'] == 0))
					{
						$info_array['disabled'] = 0;
						$info_array['is_confirmed'] = 1;
						$error = "";
						bab_updateUserById($this->user_id, $info_array, $error);
						$this->notes = undecode_html(bab_translate("Account enabled and/or confirmed", $GLOBALS['babAddonFolder']));
					}
				}
				
				// Inscription du compte dans le groupe des lves ou tudiants de l'tablissement (EtabElv)
				bab_attachUserToGroup($this->user_id, STUDENTS_GROUP_ID);
				// Inscription du compte dans la groupe des lves ou tudiants du type d'enseignement (LpElv ou StsElv)
				bab_attachUserToGroup($this->user_id, $this->type_ens_groupe_id);
				// Inscription du compte dans le groupe des lves ou tudiants de la promotion
				bab_attachUserToGroup($this->user_id, $this->group_id);
				// Inscription du compte  l'intrieur du groupe parent
				bab_attachUserToGroup($this->user_id, $this->parent_group_id);
				// Inscription du compte dans le groupe parent du groupe parent des lves ou tudiants de la promotion
				bab_attachUserToGroup($this->user_id, $this->grand_parent_group_id);
				
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new display_promotions_report_form_class($csv_import_users_array);
	$babBody->babecho(bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."import.html", "promo_report_form")); 
}


// Compte_rendu de cration des comptes par importation de liste .CSV pour les lyces d'enseignement gnral ou technologique
// (organisation en classes)
function display_classes_report_form()
{
	global $babBody;
	//global $babDB;
	global $csv_import_users_array;
	// Augmentation du temps d'excution maximale pour l'importation (port  600 s soit 10 min.)
	ini_set('max_execution_time', '600');
	
	class display_classes_report_form_class
	{
		function display_classes_report_form_class($csv_import_users_array)
		{
			global $babBody;
			global $babDB;
			require_once $GLOBALS['babInstallPath'].'admin/register.php';
			
			$this->idx = bab_rp('idx', 'LGT');
			
			$res = $babDB->db_query("
			SELECT
			`id`
			FROM
			`bab_groups`
			WHERE
			`name` = '".$babDB->db_escape_string(ucfirst($this->idx)).STUDENTS_GROUP_SUFFIX."'
			AND
			`id_parent` = '".$babDB->db_escape_string(STUDENTS_GROUP_ID)."'
			");
			if ($babDB->db_num_rows($res) === 0)
			{
				$babBody->addError(undecode_html(bab_translate("Error when data processing!", $GLOBALS['babAddonFolder'])));
				return;
			}
			else
			{
				$arr = $babDB->db_fetch_array($res);
				$this->LGTELVGROUPID = $arr['id'];
			}
			
			$this->csv_import_users_array = $csv_import_users_array;
			$this->count = count($this->csv_import_users_array);
			$this->entity_label = undecode_html(bab_translate("Class", $GLOBALS['babAddonFolder']));
			$this->lastname_label = undecode_html(bab_translate("Lastname", $GLOBALS['babAddonFolder']));
			$this->firstname_label = undecode_html(bab_translate("Firstname", $GLOBALS['babAddonFolder']));
			$this->email_label = undecode_html(bab_translate("Email", $GLOBALS['babAddonFolder']));
			$this->nickname_label = undecode_html(bab_translate("Nickname", $GLOBALS['babAddonFolder']));
			$this->password_label = undecode_html(bab_translate("Password", $GLOBALS['babAddonFolder']));
			$this->notes_label = undecode_html(bab_translate("Notes", $GLOBALS['babAddonFolder']));
			$this->import_new_list_url = $GLOBALS['babAddonUrl'].'import';
			$this->import_new_list_button_label = undecode_html(bab_translate("Import a new users list", $GLOBALS['babAddonFolder']));
			$this->img_print_src = $GLOBALS['babInstallPath']."skins/ovidentia/images/addons/".$GLOBALS['babAddonFolder']."/print.png";
			$this->print_label = undecode_html(bab_translate("Print", $GLOBALS['babAddonFolder']));
			$this->bgcolor = false;
		}
		
		function next()
		{
			global $babBody;
			global $babDB;
			
			static $k=0;
			if( $k < $this->count)
			{
				$this->bgcolor = !$this->bgcolor;
				$this->level = $this->csv_import_users_array[$k]['level'];
				$class = $this->csv_import_users_array[$k]['class'];
				$this->entity = $class;
				$this->lastname = undecode_html(mb_strtoupper($this->csv_import_users_array[$k]['lastname'], CHARSET));
				$this->firstname = undecode_html(mb_convert_case($this->csv_import_users_array[$k]['firstname'], MB_CASE_TITLE, CHARSET));
				$this->login = $this->csv_import_users_array[$k]['login'];
				$mail_domain = bab_rp('mail_domain', DEFAULT_MAIL_DOMAIN_VALUE);
				if (empty($mail_domain))
				{
					$this->email = DEFAULT_MAIL;
				}
				else
				{
					$this->email = $this->login.'@'.$mail_domain;
				}
				$this->password = $this->csv_import_users_array[$k]['password'];
				list($this->user_id, $this->nickname, $this->password) = get_user_id_and_pwd($this->lastname, $this->firstname, $this->email, $this->login, $this->password);
				$this->notes = undecode_html(bab_translate("New account", $GLOBALS['babAddonFolder']));
				
				if ($this->password == 'NC')
				{
					$this->notes = undecode_html(bab_translate("Existing account", $GLOBALS['babAddonFolder']));
					$info_array = bab_getUserInfos($this->user_id);
					if (($info_array['disabled'] == 1 ) || ($info_array['is_confirmed'] == 0))
					{
						$info_array['disabled'] = 0;
						$info_array['is_confirmed'] = 1;
						$error = "";
						bab_updateUserById($this->user_id, $info_array, $error);
						$this->notes = undecode_html(bab_translate("Account enabled and/or confirmed", $GLOBALS['babAddonFolder']));
					}
				}
				
				// Recherche des groupes imbriqus  du groupe LGT desquels l'utilisateur doit tre membre
				$res = $babDB->db_query("
				SELECT
				`bg1`.`id` AS `group_id`,
				`bg2`.`id` AS `parent_group_id`,
				`bg3`.`id` AS `grand_parent_group_id`
				FROM
				`bab_groups` AS `bg1`,
				`bab_groups` AS `bg2`,
				`bab_groups` AS `bg3`
				WHERE
				UPPER(`bg1`.`name`) = UPPER('".$babDB->db_escape_string($this->level.STUDENTS_GROUP_SUFFIX)."')
				AND
				`bg1`.`id_parent` = `bg2`.`id`
				AND
				`bg2`.`id_parent` = `bg3`.`id`
				");
				if ($babDB->db_num_rows($res) === 0)
				{
					$babBody->addError(undecode_html(bab_translate("Error when data processing!", $GLOBALS['babAddonFolder'])));
					return;
				}
				else
				{
					$arr = $babDB->db_fetch_array($res);
					$group_id = $arr['group_id'];
					$parent_group_id = $arr['parent_group_id'];
					$grand_parent_group_id = $arr['grand_parent_group_id'];
				}
				
				// Inscription du compte dans le groupe des lves et tudiants de l'tablissement
				bab_attachUserToGroup($this->user_id, STUDENTS_GROUP_ID);
				// Inscription du compte dans le groupe des lves des sections de lyce gnral ou technologique
				bab_attachUserToGroup($this->user_id, $this->LGTELVGROUPID);
				// Inscription du compte  l'intrieur du groupe LGT
				bab_attachUserToGroup($this->user_id, $grand_parent_group_id);
				// Inscription du compte dans le groupe du niveau concern ( l'intrieur du groupe LGT)
				bab_attachUserToGroup($this->user_id, $parent_group_id);
				// Inscription du compte dans le groupe des lves du niveau concern ( l'intrieur du groupe LGT)
				bab_attachUserToGroup($this->user_id, $group_id);
				// Inscription du compte dans le groupe des lves de la classe concerne
				$res = $babDB->db_query("
				SELECT
				`id`
				FROM
				`bab_groups`
				WHERE
				UPPER(`name`) = UPPER('".$babDB->db_escape_string($class.STUDENTS_GROUP_SUFFIX)."')
				AND
				`id_parent` = '".$babDB->db_escape_string($parent_group_id)."'
				");
				if ($babDB->db_num_rows($res) === 0)
				{
					$class_variables_array = create_class(ucfirst(mb_strtolower($class, CHARSET)), $this->level, 'LGT');
					create_objects_in_class(ucfirst(mb_strtolower($class, CHARSET)), $class_variables_array);
					$id_class_elv_group = $class_variables_array['id_elv_group'];
				}
				else
				{
					$temp = $babDB->db_fetch_array($res);
					$id_class_elv_group = $temp['id'];
					
				}
				bab_attachUserToGroup($this->user_id, $id_class_elv_group);
				
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new display_classes_report_form_class($csv_import_users_array);
	$babBody->babecho(bab_printTemplate($obj,$GLOBALS['babAddonHtmlPath']."import.html", "lgt_report_form")); 
}

// Affichage des erreurs rencontres lors l'importation du fichier .CSV des utilisateurs
function display_errors_form()
{
	global $babBody;
	global $error_message_array;
	
	class display_errors_form_class
	{
		function display_errors_form_class($error_message_array)
		{
			global $babBody;
			global $error_message_array;
			$idx = bab_rp('idx', 'LGT');
			$this->error_message_array = $error_message_array;
			$this->count = count($error_message_array);
			$this->return_to_previous_page = undecode_html(bab_translate("Return to previous page", $GLOBALS['babAddonFolder']));
			$this->return_url = $GLOBALS['babAddonUrl'].'import&idx='.$idx;
		}

		function next()
		{
			global $babBody;
			static $k=0;
			if( $k < $this->count)
			{
				$this->error_message = $this->error_message_array[$k] ;
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	
	$obj= new display_errors_form_class($error_message_array);
	$babBody->babecho(bab_printTemplate($obj, $GLOBALS['babAddonHtmlPath']."import.html", "display_errors_form"));
}
// Formulaire de slection du fichier des utilisateurs de lyce professionnel ou des section de techniciens suprieurs (organisation par promotions)  importer par liste .CSV ainsi que du groupe d'affectation des utilisateurs crs
function display_lp_selection_form()
{
	global $babBody;
	
	class display_lp_selection_form_class
	{
		function display_lp_selection_form_class()
		{
			global $babDB;
			global $babBody;
			
			$idx = bab_rp('idx', 'LGT');
			if ($idx === 'LP')
			{
				$type_ens = 'LP';
			}
			else
			{
				if ($idx === 'STS')
				{
					$type_ens = 'STS';
				}
				else
				{
					$babBody->addError(undecode_html(bab_translate("Error when data processing!", $GLOBALS['babAddonFolder'])));
					return;
				}
			}
		
			$this->res = $babDB->db_query("
			SELECT
			`bg1`.`id`,
			`bg1`.`name`
			FROM
			`bab_groups` AS `bg1`,
			`bab_groups` AS `bg2`,
			`bab_groups` AS `bg3`
			WHERE
			`bg1`.`name` LIKE '%".STUDENTS_GROUP_SUFFIX."'
			AND
			`bg1`.id_parent = `bg2`.id
			AND
			`bg2`.id_parent = `bg3`.id
			AND 
			`bg3`.`name` = '".$babDB->db_escape_string(mb_strtoupper($type_ens))."'
			ORDER BY
			`bg1`.`name`
			");
			$this->count = $babDB->db_num_rows($this->res);
			if ($this->count === 0)
			{
				$babBody->addError(undecode_html(bab_translate("Error! There is no created promotion.", $GLOBALS['babAddonFolder'])));
			}
			else
			{
				$this->idx = bab_rp('idx', 'LGT');
				$this->select_file_message = undecode_html(bab_translate("Select the .CSV file with the informations of the users to be imported.", $GLOBALS['babAddonFolder']));
				$this->max_file_size = MAX_FILE_SIZE;
				$max_file_size = number_format($this->max_file_size, 0, ',', ' ');
				$this->information1_tooltip = undecode_html(bab_translate("The .CSV file must have on the first ligne the four words: NAME, FIRSTNAME, LOGIN and PASSWORD in this order.", $GLOBALS['babAddonFolder']));
				$this->information1_tooltip .= "<br>\r\n".undecode_html(bab_translate("The separator is the semicolon.", $GLOBALS['babAddonFolder']));
				$this->information1_tooltip .= "<br>\r\n".sprintf(undecode_html(bab_translate("The password length must at least %s characters.", $GLOBALS['babAddonFolder'])), MIN_PASSWORD_LENGTH);
				$this->information1_tooltip .= "<br>\r\n".sprintf(undecode_html(bab_translate("The file size for the downloaded file must be less than %s bytes.", $GLOBALS['babAddonFolder'])), $max_file_size);
				$this->information2_tooltip = sprintf(undecode_html(bab_translate("If the domain name is not empty, the mail adresses will be made by the login followed by '@' and the mail domain name. Else, the mail adresses will be generic (%s).", $GLOBALS['babAddonFolder'])), DEFAULT_MAIL);
				$this->mail_domain_message = undecode_html(bab_translate("Give the name of the mail domain.", $GLOBALS['babAddonFolder']));
				$this->default_mail_domain_value = DEFAULT_MAIL_DOMAIN_VALUE;
				$this->promo_select_message = undecode_html(bab_translate("Select the promotion in the list.", $GLOBALS['babAddonFolder']));
				$this->element_select_message = undecode_html(bab_translate("Select an element.", $GLOBALS['babAddonFolder']));
				$this->information_label = undecode_html(bab_translate("Information", $GLOBALS['babAddonFolder']));
				$this->information_message = undecode_html(bab_translate("You can fix the default mail domain name in the global parameters of the addon.", $GLOBALS['babAddonFolder']));
				$this->validate = undecode_html(bab_translate("Validate", $GLOBALS['babAddonFolder']));
			}
		}
		
		function next()
		{
			global $babDB;
			
			static $k=0;
			if( $k < $this->count)
			{
				$arr = $babDB->db_fetch_array($this->res);
				$this->id = $arr['id'];
				$name = $arr['name'];
				$this->name = mb_substr($name, 0, mb_strlen($name) - mb_strlen(STUDENTS_GROUP_SUFFIX), CHARSET);
				$k++;
				return true;
			}
			else
			{
				return false;
			}
		}
	}
	$obj= new display_lp_selection_form_class();
	$babBody->babecho(bab_printTemplate($obj, $GLOBALS['babAddonHtmlPath']."import.html", "lp_selection_form"));
}

// Formulaire de slection du fichier des utilisateurs de lyce gnral ou technologique (organisation par classes)  importer par liste .CSV
function display_lgt_selection_form()
{
	global $babBody;
	
	class display_lgt_selection_form_class
	{
		function display_lgt_selection_form_class()
		{
			global $babDB;
			global $babBody;
			$this->idx = bab_rp('idx', 'LGT');
			$this->select_file_message = undecode_html(bab_translate("Select the .CSV file with the informations of the users to be imported.", $GLOBALS['babAddonFolder']));
			$this->max_file_size = MAX_FILE_SIZE;
			$max_file_size = number_format($this->max_file_size, 0, ',', ' ');
			$this->information1_tooltip = undecode_html(bab_translate("The .CSV file must have on the first ligne the six words: LEVEL, CLASS, NAME, FIRSTNAME, LOGIN and PASSWORD in this order.", $GLOBALS['babAddonFolder']));
			$this->information1_tooltip .= "<br>\r\n".undecode_html(bab_translate("The separator is the semicolon.", $GLOBALS['babAddonFolder']));
			$this->information1_tooltip .= "<br>\r\n".sprintf(undecode_html(bab_translate("The password length must at least %s characters.", $GLOBALS['babAddonFolder'])), MIN_PASSWORD_LENGTH);
			$this->information1_tooltip .= "<br>\r\n".sprintf(undecode_html(bab_translate("The file size for the downloaded file must be less than %s bytes.", $GLOBALS['babAddonFolder'])), $max_file_size);
			$this->information2_tooltip = sprintf(undecode_html(bab_translate("If the domain name is not empty, the mail adresses will be made by the login followed by '@' and the mail domain name. Else, the mail adresses will be generic (%s).", $GLOBALS['babAddonFolder'])), DEFAULT_MAIL);
			$this->mail_domain_message = undecode_html(bab_translate("Give the name of the mail domain.", $GLOBALS['babAddonFolder']));
			$this->default_mail_domain_value = DEFAULT_MAIL_DOMAIN_VALUE;
			$this->information_label = undecode_html(bab_translate("Information", $GLOBALS['babAddonFolder']));
			$this->information_message = undecode_html(bab_translate("You can fix the default mail domain name in the global parameters of the addon.", $GLOBALS['babAddonFolder']));
			$this->validate = undecode_html(bab_translate("Validate", $GLOBALS['babAddonFolder']));
		}
	}
	$obj= new display_lgt_selection_form_class();
	$babBody->babecho(bab_printTemplate($obj, $GLOBALS['babAddonHtmlPath']."import.html", "lgt_selection_form"));
}

function classes_import()
{
	global $babBody;
	global $babDB;
	
	if (bab_pp('operation', '') === 'proceed')
	{
		$babBody->setTitle(undecode_html(bab_translate("Accounts import", $GLOBALS['babAddonFolder'])));
		
		global $error_message_array;
		
		$error_message_array = array();
		
		global $csv_import_users_array;

		$csv_import_users_array = array();
		
		switch ($_FILES['csv_list']['error'])
		{
			case 8:
				$error_message_array[] = undecode_html(bab_translate("A PHP extension stopped the file upload.", $GLOBALS['babAddonFolder']));
				break;
			case 7:
				$error_message_array[] = undecode_html(bab_translate("Failed to write file to disk.", $GLOBALS['babAddonFolder']));
				break;
			case 6:
				$error_message_array[] = undecode_html(bab_translate("Missing a temporary folder.", $GLOBALS['babAddonFolder']));
				break;
			case 4:
				$error_message_array[] = undecode_html(bab_translate("No file was selected and uploaded.", $GLOBALS['babAddonFolder']));
				break;
			case 3:
				$error_message_array[] = undecode_html(bab_translate("The uploaded file was only partially uploaded.", $GLOBALS['babAddonFolder']));
				break;
			case 2:
				$max_file_size = number_format(MAX_FILE_SIZE, 0, ',', ' ');
				$error_message_array[] = sprintf(undecode_html(bab_translate("The uploaded file exceeds the MAX_FILE_SIZE directive (%s bytes), specified in the HTML form.", $GLOBALS['babAddonFolder'])), $max_file_size);
				break;	
			case 1:
				$upload_max_file_size = number_format(return_bytes(ini_get('upload_max_filesize')), 0, ',', ' ');
				$error_message_array[] = undecode_html(bab_translate("The uploaded file exceeds the upload_max_filesize directive (%s) in php.ini.", $GLOBALS['babAddonFolder']));
				break;
			case 0:
				$ext = explode(".",$_FILES["csv_list"]["name"]);
				$ext = $ext[count($ext)-1];
				if (mb_strtolower($ext) !=	"csv")
				{
					$error_message_array[] = undecode_html(bab_translate("The downloaded file must be a .CSV file.", $GLOBALS['babAddonFolder']));
				}
				else
				{
					$error_flag = false;
					$error_message_array = array();
					$row = 1;
					$handle = fopen($_FILES["csv_list"]["tmp_name"], "r");
					$data = fgetcsv($handle, 1000, ";");
					if (count($data) != CLASSES_FIELDS_NUMBER)
					{
						$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line 1 of the downloaded file: there are %u fields; you must have %u fields.", $GLOBALS['babAddonFolder'])), count($data), CLASSES_FIELDS_NUMBER);
						$error_flag = true;
					}
					
					$level = $data[0];
					$class = $data[1];
					$name = $data[2];
					$firstname = $data[3];
					$login = $data[4];
					$password = $data[5];
					$level_array = array("level", "niveau");
					$class_array = array("class", "classe");
					$name_array = array("nom", "name");
					$firstname_array = array("prenom", "pr&eacute;nom", "firstname");
					$login_array = array("login", "identifiant");
					$password_array = array("password", "motdepasse", "mot de passe");
					if (!in_array(mb_strtolower($level), $level_array) || !in_array(mb_strtolower($class), $class_array) || !in_array(mb_strtolower($name), $name_array) || !in_array(mb_strtolower(htmlentities($firstname, ENT_QUOTES, CHARSET)), $firstname_array) || !in_array(mb_strtolower($login), $login_array) || !in_array(mb_strtolower($password), $password_array))
					{
						$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line 1 of the downloaded file: it must contain the six words: LEVEL, CLASS, NAME, FIRSTNAME, LOGIN and PASSWORD in this order.", $GLOBALS['babAddonFolder'])), $row, count($data), CLASSES_FIELDS_NUMBER);
						$error_flag = true;
					}
					
					$row++;
					while ($data = fgetcsv($handle, 1000, ";"))
					{
						if (count($data) != CLASSES_FIELDS_NUMBER)
						{
							if (count($data) === 1)
							{
								$var = trim($data[0]);
								if (!empty($var)) $error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: there is one field; you must have %u fields.", $GLOBALS['babAddonFolder'])), $row, CLASSES_FIELDS_NUMBER);
							}
							else
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: there are %u fields; you must have %u fields.", $GLOBALS['babAddonFolder'])), $row, count($data), CLASSES_FIELDS_NUMBER);
							}
							$error_flag = true;
						}
						else
						{
							$level = $data[0];
							$class = $data[1];
							$lastname = $data[2];
							$firstname = $data[3];
							$login = $data[4];
							$password = $data[5];
							
							if (empty($level))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the level is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
							else
							{
								$res = $babDB->db_query("
								SELECT
								`bab_groups1`.`id`
								FROM
								`bab_groups` AS `bab_groups1`,
								`bab_groups` AS `bab_groups2`
								WHERE
								UPPER(`bab_groups1`.`name`) = UPPER('".$level."')
								AND
								`bab_groups1`.`id_parent` = `bab_groups2`.`id`
								AND
								UPPER(`bab_groups2`.`name`) = UPPER('LGT')
								");
								if ($babDB->db_num_rows($res) === 0)
								{
									$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the level does not exist.", $GLOBALS['babAddonFolder'])), $row);
									$error_flag = true;
								}
							}
							if (empty($class))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the class is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
							else
							{
								if (mb_strtolower(trim($level), CHARSET) === mb_strtolower(trim($class), CHARSET))
								{
									$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the names of class and level are the same.", $GLOBALS['babAddonFolder'])), $row);
									$error_flag = true;
								}
							}
							if (empty($lastname))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the name is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
							
							if (empty($firstname))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the firstname is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
									
							if (empty($login))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the login is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
							
							if (mb_strlen ($password, CHARSET ) < MIN_PASSWORD_LENGTH)
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the password has not at least %s characters.", $GLOBALS['babAddonFolder'])), $row, MIN_PASSWORD_LENGTH);
								$error_flag = true;
							}
							
							$csv_import_users_array[] = array('level' => $level, 'class' => $class, 'lastname' => $lastname, 'firstname' => $firstname, 'login' => $login, 'password' => $password);
						}
						
						if (!((count($data) === 1) && empty($data[0]))) $row++;
					}
					
					if ($row === 2)
					{
						$error_message_array[] = undecode_html(bab_translate("Error in the users list: the list is empty.", $GLOBALS['babAddonFolder']));
						$error_flag = true;
					}
					
					$mail_domain = bab_rp('mail_domain', DEFAULT_MAIL_DOMAIN_VALUE );
					if (!empty($mail_domain))
					{
						if (!is_regular_mail('toto@'.$mail_domain))
						{
							$error_message_array[] = sprintf(undecode_html(bab_translate("Error in the mail domain: the mail domain is not regular.", $GLOBALS['babAddonFolder'])), $mail_domain);
							$error_flag = true;
						}
					}
				}
				break;
			default:
				$babBody->addError("pb");
				break;
		}
		
		$errors_number = count($error_message_array);
		if ($errors_number == 1)
		{
			$babBody->addError(undecode_html(bab_translate("One error in the downloaded informations:", $GLOBALS['babAddonFolder'])));
			display_errors_form();
		}
		else
		{
			if ($errors_number > 1)
			{
				$babBody->addError(sprintf(undecode_html(bab_translate("%u errors in the downloaded informations:", $GLOBALS['babAddonFolder'])), $errors_number));
				display_errors_form();
			}
			else
			{
				$babBody->addError(sprintf(undecode_html(bab_translate("Report form of accounts create", $GLOBALS['babAddonFolder'])), $errors_number));
				display_classes_report_form() ;
			}
		}
	}
	else
	{
		$babBody->setTitle(undecode_html(bab_translate("Select the file to import in users database", $GLOBALS['babAddonFolder'])));
		$babBody->addError(undecode_html(bab_translate("You must have deleted all older classes before importing data!", $GLOBALS['babAddonFolder'])));
		display_lgt_selection_form();
	}
}

function promo_import()
{
	global $babBody;
	global $babDB;
	
	if (bab_pp('operation', '') === 'proceed')
	{
		$babBody->setTitle(undecode_html(bab_translate("Accounts import", $GLOBALS['babAddonFolder'])));
		
		global $error_message_array;
		
		$error_message_array = array();
		
		global $csv_import_users_array;

		$csv_import_users_array = array();
		
		$id_group = bab_pp('promo', '');
		if (empty($id_group))
		{
			$error_message_array[] = undecode_html(bab_translate("You have not selected any promotion.", $GLOBALS['babAddonFolder']));
		}
			
		switch ($_FILES['csv_list']['error'])
		{
			case 8:
				$error_message_array[] = undecode_html(bab_translate("A PHP extension stopped the file upload.", $GLOBALS['babAddonFolder']));
				break;
			case 7:
				$error_message_array[] = undecode_html(bab_translate("Failed to write file to disk.", $GLOBALS['babAddonFolder']));
				break;
			case 6:
				$error_message_array[] = undecode_html(bab_translate("Missing a temporary folder.", $GLOBALS['babAddonFolder']));
				break;
			case 4:
				$error_message_array[] = undecode_html(bab_translate("No file was selected and uploaded.", $GLOBALS['babAddonFolder']));
				break;
			case 3:
				$error_message_array[] = undecode_html(bab_translate("The uploaded file was only partially uploaded.", $GLOBALS['babAddonFolder']));
				break;
			case 2:
				$max_file_size = number_format(MAX_FILE_SIZE, 0, ',', ' ');
				$error_message_array[] = sprintf(undecode_html(bab_translate("The uploaded file exceeds the MAX_FILE_SIZE directive (%s bytes), specified in the HTML form.", $GLOBALS['babAddonFolder'])), $max_file_size);
				break;	
			case 1:
				$upload_max_file_size = number_format(return_bytes(ini_get('upload_max_filesize')), 0, ',', ' ');
				$error_message_array[] = undecode_html(bab_translate("The uploaded file exceeds the upload_max_filesize directive (%s) in php.ini.", $GLOBALS['babAddonFolder']));
				break;
			case 0:
				$ext = explode(".",$_FILES["csv_list"]["name"]);
				$ext = $ext[count($ext)-1];
				if (mb_strtolower($ext) !=	"csv")
				{
					$error_message_array[] = undecode_html(bab_translate("The downloaded file must be a .CSV file.", $GLOBALS['babAddonFolder']));
				}
				else
				{
					$error_flag = false;
					// $error_message_array = array();
					$row = 1;
					$handle = fopen($_FILES["csv_list"]["tmp_name"], "r");
					$data = fgetcsv($handle, 1000, ";");
					if (count($data) != PROMOS_FIELDS_NUMBER)
					{
						$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line 1 of the downloaded file: there are %u fields; you must have %u fields.", $GLOBALS['babAddonFolder'])), count($data), PROMOS_FIELDS_NUMBER);
						$error_flag = true;
					}
					
					$name = $data[0];
					$firstname = $data[1];
					$login = $data[2];
					$password = $data[3];
					$name_array = array("nom", "name");
					$firstname_array = array("prenom", "pr&eacute;nom", "firstname");
					$login_array = array("login", "identifiant");
					$password_array = array("password", "motdepasse", "mot de passe");
					if (!in_array(mb_strtolower($name), $name_array) || !in_array(mb_strtolower(htmlentities($firstname, ENT_QUOTES, CHARSET)), $firstname_array) || !in_array(mb_strtolower($login), $login_array) || !in_array(mb_strtolower($password), $password_array))
					{
						$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line 1 of the downloaded file: it must contain the four words: NAME, FIRSTNAME, LOGIN and PASSWORD in this order.", $GLOBALS['babAddonFolder'])), $row, count($data), PROMOS_FIELDS_NUMBER);
						$error_flag = true;
					}
					
					$row++;
					while ($data = fgetcsv($handle, 1000, ";"))
					{
						if (count($data) != PROMOS_FIELDS_NUMBER)
						{
							if (count($data) === 1)
							{
								$var = trim($data[0]);
								if (!empty($var)) $error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: there is one field; you must have %u fields.", $GLOBALS['babAddonFolder'])), $row, PROMOS_FIELDS_NUMBER);
							}
							else
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: there are %u fields; you must have %u fields.", $GLOBALS['babAddonFolder'])), $row, count($data), PROMOS_FIELDS_NUMBER);
							}
							$error_flag = true;
						}
						else
						{
							$lastname = $data[0];
							$firstname = $data[1];
							$login = $data[2];
							$password = $data[3];
							
							if (empty($lastname))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the name is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
							
							if (empty($firstname))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the firstname is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
									
							if (empty($login))
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the login is empty.", $GLOBALS['babAddonFolder'])), $row);
								$error_flag = true;
							}
							
							if (mb_strlen ($password, CHARSET ) < MIN_PASSWORD_LENGTH)
							{
								$error_message_array[] = sprintf(undecode_html(bab_translate("Error on line %u of the downloaded file: the password has not at least %s characters.", $GLOBALS['babAddonFolder'])), $row, MIN_PASSWORD_LENGTH);
								$error_flag = true;
							}
							
							$csv_import_users_array[] = array('lastname' => $lastname, 'firstname' => $firstname, 'login' => $login, 'password' => $password);
						}
						
						if (!((count($data) === 1) && empty($data[0]))) $row++;
					}
					
					if ($row === 2)
					{
						$error_message_array[] = undecode_html(bab_translate("Error in the users list: the list is empty.", $GLOBALS['babAddonFolder']));
						$error_flag = true;
					}
					
					$mail_domain = bab_rp('mail_domain', DEFAULT_MAIL_DOMAIN_VALUE );
					if (!empty($mail_domain))
					{
						if (!is_regular_mail('toto@'.$mail_domain))
						{
							$error_message_array[] = sprintf(undecode_html(bab_translate("Error in the mail domain: the mail domain is not regular.", $GLOBALS['babAddonFolder'])), $mail_domain);
							$error_flag = true;
						}
					}
				}
				break;
			default:
				$babBody->addError("pb");
				break;
		}
		
		$errors_number = count($error_message_array);
		if ($errors_number == 1)
		{
			$babBody->addError(undecode_html(bab_translate("One error in the downloaded informations:", $GLOBALS['babAddonFolder'])));
			display_errors_form();
		}
		else
		{
			if ($errors_number > 1)
			{
				$babBody->addError(sprintf(undecode_html(bab_translate("%u errors in the downloaded informations:", $GLOBALS['babAddonFolder'])), $errors_number));
				display_errors_form();
			}
			else
			{
				$babBody->addError(sprintf(undecode_html(bab_translate("Report form of accounts create", $GLOBALS['babAddonFolder'])), $errors_number));
				display_promotions_report_form() ;
			}
		}
	}
	else
	{
		$babBody->setTitle(undecode_html(bab_translate("Select the file to import in users database", $GLOBALS['babAddonFolder'])));
		display_lp_selection_form();
	}
	
}

function STS()
{
	global $babBody;
}

// Programme principal
if (bab_isUserAdministrator())
{	
	$idx = bab_rp('idx', 'LGT');
	
	switch ($idx)
	{
		case 'STS':
			$babBody->addItemMenu("LGT", bab_translate("LGT", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=LGT");
			$babBody->addItemMenu("LP", bab_translate("LP", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=LP");
			$babBody->addItemMenu("STS", bab_translate("STS", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=STS");
			promo_import();
			break;

		case 'LP':
			$babBody->addItemMenu("LGT", bab_translate("LGT", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=LGT");
			$babBody->addItemMenu("LP", bab_translate("LP", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=LP");
			promo_import();
			$babBody->addItemMenu("STS", bab_translate("STS", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=STS");
			break;
			
		case 'LGT':
		default:
			$babBody->addItemMenu("LGT", bab_translate("LGT", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=LGT");
			classes_import();
			$babBody->addItemMenu("LP", bab_translate("LP", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=LP");
			$babBody->addItemMenu("STS", bab_translate("STS", $GLOBALS['babAddonFolder']), $GLOBALS['babAddonUrl']."import&idx=STS");
			break;
	}
	
	$babBody->setCurrentItemMenu($idx);
}
else
{
	exit;
}
?>