<?php

require_once 'base.php';
require_once $GLOBALS['babAddonPhpPath'].'gestutilisateurs_ini.php';

if (!defined("CHARSET"))
{
	switch (mb_strtolower(mysql_client_encoding()))
	{
		case "utf8":
			define("CHARSET", "UTF-8");
			break;
		case 'latin1':
		default:
			define ("CHARSET", "ISO-8859-15");
			break;
	}
}

if (!function_exists('undecode_html'))
{
	function undecode_html($string)
	{
		return html_entity_decode($string, ENT_QUOTES, CHARSET);
	}
}


function gestutilisateurs_getAdminSectionMenus(&$url, &$text)
{
	return false;
}
 
function gestutilisateurs_getUserSectionMenus(&$url, &$text)
{
	return false;
}
 
function gestutilisateurs_onSectionCreate(&$title, &$content)
{
	if (bab_isUserAdministrator())
	{	
		$title = bab_translate("Utilitaries", $GLOBALS['babAddonFolder']);
		$content = "<ul>\n";
		$content .= "<li><a href=\"".$GLOBALS['babAddonUrl']."users_management\">".undecode_html(bab_translate("Users management", $GLOBALS['babAddonFolder']))."</a></li>\r\n";
		$content .= "<li><a href=\"".$GLOBALS['babAddonUrl']."site_customisation\">".undecode_html(bab_translate("Site personnalization", $GLOBALS['babAddonFolder']))."</a></li>\r\n";
		$content .= "<li><a href=\"".$GLOBALS['babAddonUrl']."import\">".undecode_html(bab_translate("Users import", $GLOBALS['babAddonFolder']))."</a></li>\r\n";
		$content .= "<li><a href=\"".$GLOBALS['babInstallPath']."addons/".$GLOBALS['babAddonFolder']."/aide.pdf\" target=\"_blank\" \">".undecode_html(bab_translate("Addon help", $GLOBALS['babAddonFolder']))."</a></li>\r\n";
		$content .= "</ul>\n";
		return true;
	}
	else
	{
		return false;
	}
}
 
function gestutilisateurs_upgrade($version_base,$version_ini)
{ 
	global $babDB;
	require_once($GLOBALS['babAddonPhpPath'].'gestutilisateurs_ini.php');
	
 	if (!bab_isTable("gestuser_parameters")) 
	{ 
		$res = $babDB->db_query(" 
		CREATE TABLE `gestuser_parameters` (
		`id` int(11) unsigned NOT NULL auto_increment,
		`id_site` int(11) unsigned DEFAULT '0' NOT NULL,
		`default_site_mail_domain` varchar(255) DEFAULT '' NOT NULL,
		PRIMARY KEY (id))
		");
	} 
	
	// Cration ventuelle du groupe des administrateurs dlgus
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = '".$babDB->db_escape_string(ADMINS_GROUP_NAME)."' 
	AND 
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = ADMINS_GROUP_NAME;
		$description = $admins_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des gestionnaires des dlgations
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = '".$babDB->db_escape_string(GESTS_GROUP_NAME)."' 
	AND 
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = GESTS_GROUP_NAME;
		$description = $gests_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	
	// Renommage ventuel du regroupement des niveaux de formation de lyce technologique en LGT
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LT' 
	AND 
	`id_parent` = '".BAB_REGISTERED_GROUP."'
	");
	if ($babDB->db_num_rows($res) > 0)
	{
		$temp = $babDB->db_fetch_array($res);
		$id = $temp["id"];
		$name = "LGT";
		$description = undecode_html(bab_translate("Groupment of levels in high school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		bab_updateGroup($id, $name, $description, $managerid); 
	}
	// Cration ventuelle du regroupement des niveaux de formation de lyce gnral ou technologique
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LGT'
	AND 
	`id_parent` = '".BAB_REGISTERED_GROUP."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'LGT';
		$description = undecode_html(bab_translate("Groupment of levels in high school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du regroupement des filires de formation des lyces professionnels
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LP'
	AND `id_parent` = '".BAB_REGISTERED_GROUP."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'LP';
		$description = undecode_html(bab_translate("Groupment of courses in professional school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du regroupement des filires de formation des sections de techniciens suprieurs
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'STS' 
	AND 
	`id_parent` = '".BAB_REGISTERED_GROUP."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'STS';
		$description = undecode_html(bab_translate("Groupment of courses in higher technicians sections", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = BAB_REGISTERED_GROUP;
		bab_createGroup($name, $description, $managerid, $parent);
	}

	// Cration ventuelle du groupe des lves et tudiants de l'tablissement (sans rpertoire privatif)
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = '".$babDB->db_escape_string(STUDENTS_GROUP_NAME)."' 
	AND 
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = STUDENTS_GROUP_NAME;
		$description = $students_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		$id_groupe_EtabElv = bab_createGroup($name, $description, $managerid);
	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$id_groupe_EtabElv = $temp["id"];
	}
	$res = $babDB->db_query("
	UPDATE 
	`bab_groups` 
	SET 
	`ustorage` = 'N' 
	WHERE 
	`id` = '".$babDB->db_escape_string($id_groupe_EtabElv)."'
	");
	// Renommage ventuel du groupe des lves en lyce gnral ou technologique
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LtElv'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabElv)."'
	");
	if ($babDB->db_num_rows($res) > 0)
	{
		$temp = $babDB->db_fetch_array($res);
		$id = $temp["id"];
		$name = "LgtElv";
		$description = undecode_html(bab_translate("Group of students from all levels in high school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		bab_updateGroup($id, $name, $description, $managerid); 
	}
	// Cration ventuelle du groupe des lves en lyce gnral ou technologique
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LgtElv'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabElv)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'LgtElv';
		$description = undecode_html(bab_translate("Group of students from all levels in high school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = $id_groupe_EtabElv;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des lves en lyce professionnel
	$res = $babDB->db_query("SELECT `id` FROM `bab_groups` WHERE (`name` = 'LpElv') AND (`id_parent` = ".$id_groupe_EtabElv.")");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'LpElv';
		$description = undecode_html(bab_translate("Group of students from all courses in professional school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = $id_groupe_EtabElv;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des tudiants des sections de techniciens suprieurs
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'StsElv'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabElv)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'StsElv';
		$description = undecode_html(bab_translate("Group of students from all courses in higher technicians sections", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = $id_groupe_EtabElv;
		bab_createGroup($name, $description, $managerid, $parent);
	}

	// Cration ventuelle du groupe des enseignants de l'tablissement (avec rpertoire privatif)
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = '".$babDB->db_escape_string(TEACHERS_GROUP_NAME)."' 
	AND 
	`id_parent` = '".$babDB->db_escape_string(BAB_REGISTERED_GROUP)."'
	");
	$count = $babDB->db_num_rows($res);
	if ($count == 0)
	{
		$name = TEACHERS_GROUP_NAME;
		$description = $teachers_group_description;
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		$parent = BAB_REGISTERED_GROUP;
		$id_groupe_EtabProf = bab_createGroup($name, $description, $managerid); 

	}
	else
	{
		$temp = $babDB->db_fetch_array($res);
		$id_groupe_EtabProf = $temp["id"];
	}
	$res = $babDB->db_query("
	UPDATE 
	`bab_groups` 
	SET 
	`ustorage` = 'Y' 
	WHERE 
	`id` = '".$babDB->db_escape_string($id_groupe_EtabProf)."'
	");
 	// Renommage ventuel du groupe des enseignants en lyce gnral ou technologique
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LtProf'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabProf)."'
	");
	if ($babDB->db_num_rows($res) > 0)
	{
		$temp = $babDB->db_fetch_array($res);
		$id = $temp["id"];
		$name = "LgtProf";
		$description = undecode_html(bab_translate("Group of teachers from all levels in high school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID'];
		bab_updateGroup($id, $name, $description, $managerid); 
	}
	// Cration ventuelle du groupe des enseignants en lyce gnral ou technologique
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LgtProf'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabProf)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'LgtProf';
		$description = undecode_html(bab_translate("Group of teachers from all levels in high school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = $id_groupe_EtabProf;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des enseignants en lyce professionnel
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'LpProf'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabProf)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'LpProf';
		$description = undecode_html(bab_translate("Group of teachers from all courses in professional school", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = $id_groupe_EtabProf;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	// Cration ventuelle du groupe des enseignants des sections de techniciens suprieurs
	$res = $babDB->db_query("
	SELECT 
	`id` 
	FROM 
	`bab_groups` 
	WHERE 
	`name` = 'StsProf'
	AND 
	`id_parent` = '".$babDB->db_escape_string($id_groupe_EtabProf)."'
	");
	if ($babDB->db_num_rows($res) == 0)
	{
		$name = 'StsProf';
		$description = undecode_html(bab_translate("Group of teachers from all courses in higher technicians sections", $GLOBALS['babAddonFolder']));
		$managerid = $GLOBALS['BAB_SESS_USERID']; ;
		$parent = $id_groupe_EtabProf;
		bab_createGroup($name, $description, $managerid, $parent);
	}
	
	return true; 
}
 
function gestutilisateurs_onDeleteAddon()
{
	return true;
}
 
?>