<?php
require_once 'base.php';

require_once($babAddonPhpPath.'gestutilisateurs_ini.php');

if (!bab_isUserAdministrator())
{
	$babBody->addError(undecode_html(bab_translate("Access denied", $GLOBALS['babAddonFolder'])));
	return;
}

$idx = bab_rp('idx', 'students');

switch($idx)
{
	case 'utilities':
		require_once($babAddonPhpPath.'users_management.utilities.inc.php');
		$babBody->addItemMenu("students", undecode_html(bab_translate("Students", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=students");
		$babBody->addItemMenu("teachers", undecode_html(bab_translate("Teachers", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=teachers");
		$babBody->addItemMenu("utilities", undecode_html(bab_translate("Utilities", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=utilities");
		$babBody->title = undecode_html(bab_translate("Removing of desactivated accounts", $GLOBALS['babAddonFolder']));
		$flag = bab_pp('flag', '');
		if (empty($flag))
		{
			displayRemovingDesactivedUsersForm();
		}
		else
		{
			actionRemovingDesactivedUsersForm();
		}
		break;	
	
	case 'teachers':
		require_once($babAddonPhpPath.'users_management.teachers.inc.php');
		$babBody->addItemMenu("students", undecode_html(bab_translate("Students", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=students");
		$babBody->addItemMenu("teachers", undecode_html(bab_translate("Teachers", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=teachers");
		$code_op = bab_pp('code_op', '');
		switch($code_op)
		{
			case 'T32':
				$babBody->title = "3 - ".undecode_html(bab_translate("Affectation of teachers in classes groups", $GLOBALS['babAddonFolder']));
				actionAttachmentTeachersForm();
				break;
			case 'T31':
				$babBody->title = "3 - ".undecode_html(bab_translate("Affectation of teachers in classes groups", $GLOBALS['babAddonFolder']));
				displayAttachmentTeachersForm();
				break;
				
			case 'T22':
				$babBody->title = "2 - ".undecode_html(bab_translate("Suppression of former teachers accounts", $GLOBALS['babAddonFolder']));
				actionRemovingFormerTeachersForm();
				break;
			case 'T21':
				$babBody->title = "2 - ".undecode_html(bab_translate("Suppression of former teachers accounts", $GLOBALS['babAddonFolder']));
				displayRemovingFormerTeachersForm();
				break;
				
			case 'T14':
				$babBody->title = "1 - ".bab_translate("Inscription of the new teachers", $GLOBALS['babAddonFolder']);
				$babBody->addError(undecode_html(bab_translate("Creation of the accounts for the new teachers", $GLOBALS['babAddonFolder'])));
				actionTeachersCreationForm();
				break;
			case 'T13':
				$babBody->title = "1 - ".undecode_html(bab_translate("Inscription of the new teachers", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Choice a rule for the composition of the nickname.", $GLOBALS['babAddonFolder'])));
				displayTeachersNicknameForm();
				break;
			case 'T12':
				$babBody->title = "1 - ".undecode_html(bab_translate("Inscription of the new teachers", $GLOBALS['babAddonFolder']));
				displayTeachersPasswordForm();
				break;
			case 'T11':
				$babBody->title = "1 - ".undecode_html(bab_translate("Inscription of the new teachers", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Enter the lastname, firstname and email of the new teachers.", $GLOBALS['babAddonFolder'])));
				displayTeachersInscriptionForm();
				break;
			default:
				$babBody->title = bab_translate("Teachers management", $GLOBALS['babAddonFolder']);
				$babBody->addError(undecode_html(bab_translate("Select the operation.", $GLOBALS['babAddonFolder'])));
				displayTeachersMainMenuForm();
				break;
		}
		$babBody->addItemMenu("utilities", undecode_html(bab_translate("Utilities", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=utilities");
		break;
	
	case 'students':
	default:
		require_once($babAddonPhpPath.'users_management.students.inc.php');
		$babBody->addItemMenu("students", undecode_html(bab_translate("Students", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=students");
		$code_op = bab_pp('code_op', '');
		switch ($code_op)
		{
			case 'S332':
				$babBody->title = "3.3 - ".undecode_html(bab_translate("Ponctual students management in technicians courses", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("List of the complementary created accounts", $GLOBALS['babAddonFolder'])));
				actionPonctualManagementForm();
				break;
			case 'S331':
				$babBody->title = "3.3 - ".undecode_html(bab_translate("Ponctual students management in technicians courses", $GLOBALS['babAddonFolder']));
				displayPasswordChoiceForm();
				break;
			case 'S33':
				$babBody->title = "3.3 - ".undecode_html(bab_translate("Ponctual students management in technicians courses", $GLOBALS['babAddonFolder']));
				displayPonctualManagementInTechniciansSectionsForm();
				break;
				
			case 'S322':
				$babBody->title = "3.2 - ".undecode_html(bab_translate("Ponctual students management in professionnal school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("List of the complementary created accounts", $GLOBALS['babAddonFolder'])));
				actionPonctualManagementForm();
				break;
			case 'S321':
				$babBody->title = "3.2 - ".undecode_html(bab_translate("Ponctual students management in professionnal school", $GLOBALS['babAddonFolder']));
				displayPasswordChoiceForm();
				break;
			case 'S32':
				$babBody->title = "3.2 - ".undecode_html(bab_translate("Ponctual students management in professionnal school", $GLOBALS['babAddonFolder']));
				displayPonctualManagementInProfessionnalSchoolForm();
				break;
				
			case 'S312':
				$babBody->title = "3.1 - ".undecode_html(bab_translate("Ponctual pupils management in high school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("List of the complementary created accounts", $GLOBALS['babAddonFolder'])));
				actionPonctualManagementForm();
				break;
			case 'S311':
				$babBody->title = "3.1 - ".undecode_html(bab_translate("Ponctual pupils management in high school", $GLOBALS['babAddonFolder']));
				displayPasswordChoiceForm();
				break;
			case 'S31':
				$babBody->title = "3.1 - ".undecode_html(bab_translate("Ponctual pupils management in high school", $GLOBALS['babAddonFolder']));
				displayPonctualManagementInHighSchoolForm();
				break;
			
			case 'S3':
				$babBody->title = "3 - ".undecode_html(bab_translate("Ponctual students management", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Select the operation.", $GLOBALS['babAddonFolder'])));
				displayPonctualManagementMenuForm();
				break;
			
			case 'S263':
				$babBody->title = "2.6 - ".undecode_html(bab_translate("Management of new students in higher technicians courses", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("List of the created promotions", $GLOBALS['babAddonFolder'])));
				actionCreatePromotionForm();
				break;
			case 'S262':
				$babBody->title = "2.6 - ".undecode_html(bab_translate("Management of new students in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayPasswordsChoiceForm();
				break;				
			case 'S261' :
				$babBody->title = "2.6 - ".undecode_html(bab_translate("Management of new students in higher technicians courses", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Fill the form ans click on the Next step button", $GLOBALS['babAddonFolder'])));
				displayAnnualCreationInTechniciansSectionsForm();
				break;				
			case 'S26' :
				$babBody->title = "2.6 - ".undecode_html(bab_translate("Management of new students in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayAnnualCreationInTechniciansSectionsWarning();
				break;
			
			case 'S252' :
				$babBody->title = "2.5 - ".undecode_html(bab_translate("Management of former students in higher technicians courses", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Orientation report", $GLOBALS['babAddonFolder'])));
				actionAnnualOrientationForm();
				break;
			case 'S251' :
				$babBody->title = "2.5 - ".undecode_html(bab_translate("Management of former students in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayAnnualOperationInTechniciansCoursesForm();
				break;
			case 'S25' :
				$babBody->title = "2.5 - ".undecode_html(bab_translate("Management of former students in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayAnnualOperationInTechniciansCoursesSelect();
				break;
			
			case 'S243':
				$babBody->title = "2.4 - ".undecode_html(bab_translate("Management of new students in professional school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("List of the created promotions", $GLOBALS['babAddonFolder'])));
				actionCreatePromotionForm();
				break;
			case 'S242':
				$babBody->title = "2.4 - ".undecode_html(bab_translate("Management of new students in professional school", $GLOBALS['babAddonFolder']));
				displayPasswordsChoiceForm();
				break;				
			case 'S241' :
				$babBody->title = "2.4 - ".undecode_html(bab_translate("Management of new students in professional school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Fill the form ans click on the Next step button", $GLOBALS['babAddonFolder'])));
				displayAnnualCreationInProfessionalSchoolForm();
				break;				
			case 'S24' :
				$babBody->title = "2.4 - ".undecode_html(bab_translate("Management of new students in professional school", $GLOBALS['babAddonFolder']));
				displayAnnualCreationInProfessionalSchoolWarning();
				break;
				
			case 'S232' :
				$babBody->title = "2.3 - ".undecode_html(bab_translate("Management of former students in professional school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Orientation report", $GLOBALS['babAddonFolder'])));
				actionAnnualOrientationForm();
				break;
			case 'S231' :
				$babBody->title = "2.3 - ".undecode_html(bab_translate("Management of former students in professional school", $GLOBALS['babAddonFolder']));
				displayAnnualOperationInProfessionalSchoolForm();
				break;
			case 'S23' :
				$babBody->title = "2.3 - ".undecode_html(bab_translate("Management of former students in professional school", $GLOBALS['babAddonFolder']));
				displayAnnualOperationInProfessionalSchoolSelect();
				break;
			
			case 'S223':
				$babBody->title = "2.2 - ".undecode_html(bab_translate("Management of new students in high school", $GLOBALS['babAddonFolder']));
				actionAnnualCreationInHighSchoolForm();
				break;
			case 'S222':
				$babBody->title = "2.2 - ".undecode_html(bab_translate("Management of new students in high school", $GLOBALS['babAddonFolder']));
				displayPasswordsChoiceForm();
				break;
			case 'S221':
				$babBody->title = "2.2 - ".undecode_html(bab_translate("Management of new students in high school", $GLOBALS['babAddonFolder']));
				displayAnnualCreationInHighSchoolForm();
				break;
			case 'S22':
				$babBody->title = "2.2 - ".undecode_html(bab_translate("Management of new students in high school", $GLOBALS['babAddonFolder']));
				displayAnnualCreationInHighSchoolWarningForm();
				break;
				
			case 'S211':
				$babBody->title = "2.1 - ".undecode_html(bab_translate("Management of former students in high school", $GLOBALS['babAddonFolder']));
				actionAnnualRemovingInHighSchoolForm();
				break;
			case 'S21':
				$babBody->title = "2.1 - ".undecode_html(bab_translate("Management of former students in high school", $GLOBALS['babAddonFolder']));
				displayAnnualRemovingInHighSchoolForm();
				break;
			case 'S2':
				$babBody->title = "2 - ".undecode_html(bab_translate("Annual students management", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Select the operation.", $GLOBALS['babAddonFolder'])));
				displayAnnualManagingMenuForm();
				break;

		case 'S161':
				$babBody->title = "1.6 - ".undecode_html(bab_translate("Removing of sections in higher technicians courses", $GLOBALS['babAddonFolder']));
				actionDelegationDeleteForm();
				break;
		case 'S16':
				$babBody->title = "1.6 - ".undecode_html(bab_translate("Removing of sections in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayHigherTechniciansCourseDeleteForm();
				break;

		case 'S153':
				$babBody->title = "1.5 - ".undecode_html(bab_translate("Creation of new sections in higher technicians courses", $GLOBALS['babAddonFolder']));
				actionHigherTechniciansCreationForm();
				break;
			case 'S152':
				$babBody->title = "1.5 - ".undecode_html(bab_translate("Creation of new sections in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayPasswordForm();
				break;
			case 'S151':
				$babBody->title = "1.5 - ".undecode_html(bab_translate("Creation of new sections in higher technicians courses", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Enter the name of the courses to be created and select the number of years for the formation.", $GLOBALS['babAddonFolder'])));
				displayHigherTechniciansCreationForm();
				break;
			case 'S15':
				$babBody->title = "1.5 - ".undecode_html(bab_translate("Creation of new sections in higher technicians courses", $GLOBALS['babAddonFolder']));
				displayHigherTechniciansCreationWarning();
				break;
				
			case 'S141':
				$babBody->title = "1.4 - ".undecode_html(bab_translate("Removing of courses in professional school", $GLOBALS['babAddonFolder']));
				actionDelegationDeleteForm();
				break;
			case 'S14':
				$babBody->title = "1.4 - ".undecode_html(bab_translate("Removing of courses in professional school", $GLOBALS['babAddonFolder']));
				displayProfessionalSchoolCourseDeleteForm();
				break;

				case 'S133':
				$babBody->title = "1.3 - ".undecode_html(bab_translate("Creation of new courses in professional school", $GLOBALS['babAddonFolder']));
				actionProfessionalSchoolCreationForm();
				break;
			case 'S132':
				$babBody->title = "1.3 - ".undecode_html(bab_translate("Creation of new courses in professional school", $GLOBALS['babAddonFolder']));
				displayPasswordForm();
				break;
			case 'S131':
				$babBody->title = "1.3 - ".undecode_html(bab_translate("Creation of new courses in professional school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Enter the name of the courses to be created and select the type and the number of years for the formation.", $GLOBALS['babAddonFolder'])));
				displayProfessionalSchoolCreationForm();
				break;
			case 'S13':
				$babBody->title = "1.3 - ".undecode_html(bab_translate("Creation of new courses in professional school", $GLOBALS['babAddonFolder']));
				displayProfessionalSchoolCreationWarning();
				break;
			
			case 'S121':
				$babBody->title = "1.2 - ".undecode_html(bab_translate("Removing of levels in high school", $GLOBALS['babAddonFolder']));
				actionDelegationDeleteForm();
				break;
			case 'S12':
				$babBody->title = "1.2 - ".undecode_html(bab_translate("Removing of levels in high school", $GLOBALS['babAddonFolder']));
				displayHighSchoolLevelDeleteForm();
				break;

			case 'S113':
				$babBody->title = "1.1 - ".undecode_html(bab_translate("Creation of new levels in high school", $GLOBALS['babAddonFolder']));
				actionHighSchoolLevelCreationForm();
				break;
			case 'S112':
				$babBody->title = "1.1 - ".undecode_html(bab_translate("Creation of new levels in high school", $GLOBALS['babAddonFolder']));
				displayPasswordForm();
				break;
			case 'S111':
				$babBody->title = "1.1 - ".undecode_html(bab_translate("Creation of new levels in high school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Enter the name of the levels to be created.", $GLOBALS['babAddonFolder'])));
				displayHighSchoolLevelCreationForm();
				break;
			case 'S11':
				$babBody->title = "1.1 - ".undecode_html(bab_translate("Creation of new levels in high school", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Click on the Next step button.", $GLOBALS['babAddonFolder'])));
				displayHighSchoolLevelCreationWarning();
				break;
			case 'S1':
				$babBody->title = "1 - ".bab_translate("Creation/deletion of levels or training courses", $GLOBALS['babAddonFolder']);
				$babBody->addError(undecode_html(bab_translate("Select the operation.", $GLOBALS['babAddonFolder'])));
				displayLevelCreationRemovalMenuForm();
				break;
			case '':
			default :
				$babBody->title = undecode_html(bab_translate("Students management", $GLOBALS['babAddonFolder']));
				$babBody->addError(undecode_html(bab_translate("Select the operation.", $GLOBALS['babAddonFolder'])));
				displayStudentsMainMenuForm();
				break;				
		}
		$babBody->addItemMenu("teachers", undecode_html(bab_translate("Teachers", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=teachers");
		$babBody->addItemMenu("utilities", undecode_html(bab_translate("Utilities", $GLOBALS['babAddonFolder'])), $GLOBALS['babAddonUrl']."users_management&idx=utilities");
		break;
}
$babBody->setCurrentItemMenu($idx);
?>